/** @packageDocumentation
 * @module Breadcrumb
 */
import { UiEvent } from "@bentley/ui-core";
import { TreeDataProvider, TreeNodeItem } from "../tree/TreeDataProvider";
/** BreadcrumbChangeEvent Event Args class.
 * @beta
 */
export interface BreadcrumbUpdateEventArgs {
    dataProvider: TreeDataProvider;
    oldDataProvider: TreeDataProvider;
    currentNode: TreeNodeItem | undefined;
}
/** BreadcrumbChangeEvent Event class.
 * @beta
 */
export declare class BreadcrumbUpdateEvent extends UiEvent<BreadcrumbUpdateEventArgs> {
}
/** Breadcrumb Path class.
 * @beta
 */
export declare class BreadcrumbPath {
    private _dataProvider;
    private _currentNode;
    private _breadcrumbUpdateEvent;
    get BreadcrumbUpdateEvent(): BreadcrumbUpdateEvent;
    constructor(dataProvider: TreeDataProvider);
    getDataProvider(): TreeDataProvider;
    setDataProvider(dataProvider: TreeDataProvider): void;
    getCurrentNode(): TreeNodeItem | undefined;
    setCurrentNode(currentNode: TreeNodeItem | undefined): void;
}
//# sourceMappingURL=BreadcrumbPath.d.ts.map