"use strict";
/*---------------------------------------------------------------------------------------------
* Copyright (c) Bentley Systems, Incorporated. All rights reserved.
* See LICENSE.md in the project root for license terms and full copyright notice.
*--------------------------------------------------------------------------------------------*/
/** @packageDocumentation
 * @module Breadcrumb
 */
Object.defineProperty(exports, "__esModule", { value: true });
exports.BreadcrumbPath = exports.BreadcrumbUpdateEvent = void 0;
const ui_core_1 = require("@bentley/ui-core");
/** BreadcrumbChangeEvent Event class.
 * @beta
 */
class BreadcrumbUpdateEvent extends ui_core_1.UiEvent {
}
exports.BreadcrumbUpdateEvent = BreadcrumbUpdateEvent;
/** Breadcrumb Path class.
 * @beta
 */
class BreadcrumbPath {
    constructor(dataProvider) {
        this._currentNode = undefined;
        this._breadcrumbUpdateEvent = new BreadcrumbUpdateEvent();
        this._dataProvider = dataProvider;
    }
    get BreadcrumbUpdateEvent() { return this._breadcrumbUpdateEvent; }
    getDataProvider() {
        return this._dataProvider;
    }
    setDataProvider(dataProvider) {
        this.BreadcrumbUpdateEvent.emit({ dataProvider, oldDataProvider: this._dataProvider, currentNode: this._currentNode });
        this._dataProvider = dataProvider;
    }
    getCurrentNode() {
        return this._currentNode;
    }
    setCurrentNode(currentNode) {
        this.BreadcrumbUpdateEvent.emit({ dataProvider: this._dataProvider, oldDataProvider: this._dataProvider, currentNode });
        this._currentNode = currentNode;
    }
}
exports.BreadcrumbPath = BreadcrumbPath;
//# sourceMappingURL=BreadcrumbPath.js.map