import { ColumnDescription, RowItem, TableDataProvider } from "../table/TableDataProvider";
import { TreeDataProvider, TreeNodeItem } from "../tree/TreeDataProvider";
/**
 * Utility class for tree searching and manipulation in the Breadcrumb component.
 * @beta
 */
export declare class BreadcrumbTreeUtils {
    private static createIcon;
    private static createLabel;
    private static createDescription;
    /**
     * Transforms a list of children from a tree node into a [[TableDataProvider]], given a list of column descriptions.
     * @param nodes Node list to use as a basis for the [[TableDataProvider]].
     * @param columns An array of column descriptions to specify which columns to provide to the resulting [[TableDataProvider]].
     * @returns A [[TableDataProvider]] object that can be used to populate a Table component.
     */
    static aliasNodeListToTableDataProvider(nodes: TreeNodeItem[], columns: ColumnDescription[], treeDataProvider?: TreeDataProvider): TableDataProvider;
}
/** @internal */
export interface DataRowItem extends RowItem {
    _node?: TreeNodeItem;
}
//# sourceMappingURL=BreadcrumbTreeUtils.d.ts.map