/** @packageDocumentation
 * @module Breadcrumb
 */
import * as React from "react";
import { DragSourceProps, DropTargetProps } from "../../../dragdrop/DragDropDef";
import { TableDataProvider } from "../../../table/TableDataProvider";
import { TreeNodeItem } from "../../../tree/TreeDataProvider";
import { BreadcrumbDetailsProps } from "../BreadcrumbDetails";
/**
 * Type for drag and drop,
 * @beta
 * @deprecated
 */
export declare type BreadcrumbDetailsDragDropType = {} | TreeNodeItem | TableDataProvider;
/**
 * Props that are injected to the HOC component.
 * @beta
 * @deprecated
 */
export interface BreadcrumbDetailsDragDropProps<DragDropObject = any> {
    dragProps?: DragSourceProps<DragDropObject>;
    dropProps?: DropTargetProps<DragDropObject>;
}
/**
 * A HOC component that adds drag and drop functionality to the supplied
 * breadcrumb component.
 * @beta
 * @deprecated
 */
export declare function withBreadcrumbDetailsDragDrop<P extends BreadcrumbDetailsProps, DragDropObject extends BreadcrumbDetailsDragDropType>(BreadcrumbComponent: React.ComponentType<P>): React.ComponentType<P & BreadcrumbDetailsDragDropProps<DragDropObject>>;
//# sourceMappingURL=withDragDrop.d.ts.map