"use strict";
/*---------------------------------------------------------------------------------------------
* Copyright (c) Bentley Systems, Incorporated. All rights reserved.
* See LICENSE.md in the project root for license terms and full copyright notice.
*--------------------------------------------------------------------------------------------*/
/** @packageDocumentation
 * @module Breadcrumb
 */
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.DragDropBreadcrumbNode = exports.DragDropBreadcrumbNodeComponent = void 0;
const classnames_1 = __importDefault(require("classnames"));
const React = __importStar(require("react"));
const withDragSource_1 = require("../../dragdrop/withDragSource");
const withDropTarget_1 = require("../../dragdrop/withDropTarget");
// Used internally in ./Breadcrumb.tsx
/** @internal */
class DragDropBreadcrumbNodeComponent extends React.Component {
    render() {
        const _a = this.props, { isOver, isDragging, canDrag, canDrop } = _a, props = __rest(_a, ["isOver", "isDragging", "canDrag", "canDrop"]); // eslint-disable-line @typescript-eslint/no-unused-vars
        const classes = classnames_1.default("components-breadcrumb-drop-target", {
            hover: canDrop && isOver,
            dragging: isDragging,
        });
        return (React.createElement("div", Object.assign({ className: classes }, props), this.props.children));
    }
}
exports.DragDropBreadcrumbNodeComponent = DragDropBreadcrumbNodeComponent;
/** @internal */
function DragDropBreadcrumbNode() {
    return withDropTarget_1.withDropTarget(withDragSource_1.withDragSource(DragDropBreadcrumbNodeComponent));
}
exports.DragDropBreadcrumbNode = DragDropBreadcrumbNode;
//# sourceMappingURL=DragDropBreadcrumbNode.js.map