/** @packageDocumentation
 * @module Breadcrumb
 */
import * as React from "react";
import { DragSourceProps, DropTargetProps } from "../../dragdrop/DragDropDef";
import { TreeDragDropType } from "../../tree/deprecated/hocs/withDragDrop";
import { BreadcrumbProps } from "../Breadcrumb";
/**
 * Props that are injected to the HOC component.
 * @beta
 * @deprecated
 */
export interface BreadcrumbDragDropProps<DragDropObject = any> {
    dragProps?: DragSourceProps<DragDropObject>;
    dropProps?: DropTargetProps<DragDropObject>;
}
/**
 * A HOC component that adds drag and drop functionality to the supplied breadcrumb component.
 * @beta
 * @deprecated
 */
export declare function withBreadcrumbDragDrop<P extends BreadcrumbProps, DragDropObject extends TreeDragDropType>(BreadcrumbComponent: React.ComponentType<P>): React.ComponentType<P & BreadcrumbDragDropProps<DragDropObject>>;
//# sourceMappingURL=withDragDrop.d.ts.map