/** @packageDocumentation
 * @module Color
 */
import "./AlphaSlider.scss";
import * as React from "react";
import { CommonProps } from "@bentley/ui-core";
/** Properties for the [[AlphaSlider]] React component
 * @beta
 */
export interface AlphaSliderProps extends React.HTMLAttributes<HTMLDivElement>, CommonProps {
    /** true if slider is oriented horizontal, else vertical orientation is assumed */
    isHorizontal?: boolean;
    /** function to run when user selects color swatch */
    onAlphaChange?: ((alpha: number) => void) | undefined;
    /** Alpha value between 0 (transparent) and 1 (opaque) */
    alpha: number;
}
/** AlphaSlider component used to set the alpha value.
 * @beta
 */
export declare class AlphaSlider extends React.PureComponent<AlphaSliderProps> {
    private _container;
    private _transparencyLabel;
    /** @internal */
    constructor(props: AlphaSliderProps);
    private _calculateChange;
    /** @internal */
    componentWillUnmount(): void;
    private _onChange;
    private _onMouseDown;
    private _onKeyDown;
    private _onMouseUp;
    private _unbindEventListeners;
    /** @internal */
    render(): React.ReactNode;
}
//# sourceMappingURL=AlphaSlider.d.ts.map