/** @packageDocumentation
 * @module Color
 */
import { ColorDef } from "@bentley/imodeljs-common";
/** Properties for the [[ColorPickerDialog]] React component
 * @beta
 */
export interface ColorPickerDialogProps {
    dialogTitle: string;
    color: ColorDef;
    onOkResult: (selectedColor: ColorDef) => void;
    onCancelResult: () => void;
    colorPresets?: ColorDef[];
}
/**
 * Color Picker Dialog to use as modal dialog.
 * @beta
 */
export declare function ColorPickerDialog({ dialogTitle, color, onOkResult, onCancelResult, colorPresets }: ColorPickerDialogProps): JSX.Element;
//# sourceMappingURL=ColorPickerDialog.d.ts.map