/** @packageDocumentation
 * @module Color
 */
import "./HueSlider.scss";
import * as React from "react";
import { HSVColor } from "@bentley/imodeljs-common";
import { CommonProps } from "@bentley/ui-core";
/** Properties for the [[HueSlider]] React component
 * @beta
 */
export interface HueSliderProps extends React.HTMLAttributes<HTMLDivElement>, CommonProps {
    /** true if slider is oriented horizontal, else vertical orientation is assumed */
    isHorizontal?: boolean;
    /** function to run when user hue is changed */
    onHueChange?: ((hue: HSVColor) => void) | undefined;
    /** HSV Color Value */
    hsv: HSVColor;
}
/** HueSlider component used to set the hue value.
 * @beta
 */
export declare function HueSlider({ isHorizontal, onHueChange, hsv, className, style }: HueSliderProps): JSX.Element;
//# sourceMappingURL=HueSlider.d.ts.map