/** @packageDocumentation
 * @module Color
 */
import "./SaturationPicker.scss";
import * as React from "react";
import { HSVColor } from "@bentley/imodeljs-common";
import { CommonProps } from "@bentley/ui-core";
/** Properties for the [[SaturationPicker]] React component
 * @beta
 */
export interface SaturationPickerProps extends React.HTMLAttributes<HTMLDivElement>, CommonProps {
    /** function to run when user selects location in saturation region */
    onSaturationChange?: ((saturation: HSVColor) => void) | undefined;
    /** HSV Color Value */
    hsv: HSVColor;
}
/** SaturationPicker component used to set the saturation value.
 * @beta
 */
export declare function SaturationPicker({ onSaturationChange, hsv, className, style }: SaturationPickerProps): JSX.Element;
//# sourceMappingURL=SaturationPicker.d.ts.map