/** @packageDocumentation
 * @module Color
 */
import "./Swatch.scss";
import * as React from "react";
import { ColorDef } from "@bentley/imodeljs-common";
import { CommonProps } from "@bentley/ui-core";
/** Properties for the [[ColorSwatch]] React component
 * @beta
 */
export interface ColorSwatchProps extends React.ButtonHTMLAttributes<HTMLButtonElement>, CommonProps {
    /** color specification */
    colorDef: ColorDef;
    /** function to run when user selects color swatch */
    onColorPick?: ((color: ColorDef, e: React.MouseEvent) => void) | undefined;
    /** Show swatches as squares unless round is set to true */
    round?: boolean;
}
/** ColorSwatch Functional component displays a color swatch in a button
 * @beta
 */
export declare function ColorSwatch(props: ColorSwatchProps): JSX.Element;
//# sourceMappingURL=Swatch.d.ts.map