"use strict";
/*---------------------------------------------------------------------------------------------
* Copyright (c) Bentley Systems, Incorporated. All rights reserved.
* See LICENSE.md in the project root for license terms and full copyright notice.
*--------------------------------------------------------------------------------------------*/
/** @packageDocumentation
 * @module Color
 */
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ColorSwatch = void 0;
require("./Swatch.scss");
const classnames_1 = __importDefault(require("classnames"));
const React = __importStar(require("react"));
const getCSSColorFromDef_1 = require("./getCSSColorFromDef");
/** ColorSwatch Functional component displays a color swatch in a button
 * @beta
 */
function ColorSwatch(props) {
    const rgbaString = getCSSColorFromDef_1.getCSSColorFromDef(props.colorDef);
    const colorStyle = Object.assign({ backgroundColor: rgbaString }, props.style);
    const handleClick = (e) => {
        // istanbul ignore else
        if (props && props.onColorPick)
            props.onColorPick(props.colorDef, e);
    };
    const classes = classnames_1.default("components-color-swatch", props.round && "round", props.className);
    const _a = props, { 
    // eslint-disable-next-line @typescript-eslint/no-unused-vars
    onColorPick, colorDef, round } = _a, // do not pass on color swatch specific props
    // eslint-disable-next-line comma-dangle
    otherProps = __rest(_a, ["onColorPick", "colorDef", "round"]) // pass-through props
    ;
    return React.createElement("button", Object.assign({}, otherProps, { style: colorStyle, className: classes, onClick: handleClick }));
}
exports.ColorSwatch = ColorSwatch;
//# sourceMappingURL=Swatch.js.map