"use strict";
/*---------------------------------------------------------------------------------------------
* Copyright (c) Bentley Systems, Incorporated. All rights reserved.
* See LICENSE.md in the project root for license terms and full copyright notice.
*--------------------------------------------------------------------------------------------*/
/** @packageDocumentation
 * @module Color
 */
Object.defineProperty(exports, "__esModule", { value: true });
exports.getCSSColorFromDef = void 0;
/** @internal */
function getCSSColorFromDef(colorDef) {
    const { b, g, r, t } = colorDef.colors;
    let rgbaString = "";
    if (t === 0)
        rgbaString = `rgb(${r},${g},${b})`;
    else {
        const alpha = ((255 - t) / 255).toFixed(2);
        rgbaString = `rgba(${r},${g},${b},${alpha})`;
    }
    return rgbaString;
}
exports.getCSSColorFromDef = getCSSColorFromDef;
//# sourceMappingURL=getCSSColorFromDef.js.map