"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ConditionalAutoSizer = void 0;
/*---------------------------------------------------------------------------------------------
* Copyright (c) Bentley Systems, Incorporated. All rights reserved.
* See LICENSE.md in the project root for license terms and full copyright notice.
*--------------------------------------------------------------------------------------------*/
const React = __importStar(require("react"));
const react_virtualized_auto_sizer_1 = __importDefault(require("react-virtualized-auto-sizer"));
/**
 * Supplies child element with parent element's content width and height. If width and height are specified in the
 * props, these dimensions are forwarded to child without too much overhead. Otherwise, `AutoSizer` from
 * `react-virtualized-auto-sizer` is employed to measure available space and mount the children when the dimensions
 * become known.
 *
 * This component is intended to aid towards `react-virtualized-auto-sizer` package removal, do not use this in new
 * components.
 * @internal
 */
function ConditionalAutoSizer(props) {
    const { width, height, onResize, children } = props;
    React.useLayoutEffect(() => {
        if (width !== undefined && height !== undefined && onResize !== undefined) {
            onResize({ width, height });
        }
    }, [width, height, onResize]);
    if (width !== undefined && height !== undefined) {
        return React.createElement(React.Fragment, null, children({ width, height }));
    }
    return (React.createElement(react_virtualized_auto_sizer_1.default, { disableWidth: width !== undefined, disableHeight: height !== undefined, defaultWidth: width, defaultHeight: height, onResize: onResize }, children));
}
exports.ConditionalAutoSizer = ConditionalAutoSizer;
//# sourceMappingURL=ConditionalAutoSizer.js.map