"use strict";
/*---------------------------------------------------------------------------------------------
* Copyright (c) Bentley Systems, Incorporated. All rights reserved.
* See LICENSE.md in the project root for license terms and full copyright notice.
*--------------------------------------------------------------------------------------------*/
/** @packageDocumentation
 * @module Common
 */
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.DelayedSpinner = void 0;
const React = __importStar(require("react"));
const ui_core_1 = require("@bentley/ui-core");
/**
 * Spinner that is rendered with delay.
 * @internal
 */
function DelayedSpinner(props) {
    var _a, _b;
    const delay = (_a = props.delay) !== null && _a !== void 0 ? _a : 500;
    const [loadStart] = React.useState(props.loadStart || new Date());
    const currTime = new Date();
    const diff = (currTime.getTime() - loadStart.getTime());
    const update = useForceUpdate();
    React.useEffect(() => {
        if (diff >= delay)
            return;
        const timer = setTimeout(update, delay - diff);
        return () => clearTimeout(timer);
    });
    if (diff < delay)
        return null;
    return (React.createElement(ui_core_1.Spinner, { size: (_b = props.size) !== null && _b !== void 0 ? _b : ui_core_1.SpinnerSize.Large }));
}
exports.DelayedSpinner = DelayedSpinner;
const useForceUpdate = () => {
    const [value, set] = React.useState(true);
    return () => set(!value);
};
//# sourceMappingURL=DelayedSpinner.js.map