/** @packageDocumentation
 * @module Common
 */
/**
 * Properties of [[HighlightedText]]
 * @beta
 */
export interface HighlightedTextProps {
    searchText: string;
    activeMatchIndex?: number;
    text: string;
    /** Should search be case sensitive */
    caseSensitive?: boolean;
}
/**
 * Highlighted text
 * Used for highlighting parts in the 'text' which match with 'searchText'
 * Also actively highlights one matched part which is selected with 'activeMatchIndex'
 * @beta
 */
export declare function HighlightedText(props: HighlightedTextProps): JSX.Element;
//# sourceMappingURL=HighlightedText.d.ts.map