/** @packageDocumentation
 * @module Common
 */
import * as React from "react";
import { Image } from "./IImageLoader";
/** A class that renders images from data provided by an image loader
 * @internal
 */
export declare class ImageRenderer {
    private hexToBase64;
    /** Render raw binary image */
    private renderBinary;
    /** Render svg string into JSX */
    private renderSvg;
    /** Render image from an url */
    private renderUrl;
    /** Render image as ui-core icon */
    private renderCoreIcon;
    /** Replaces the escaped instances of "\:" with ":" */
    private normalizeEscapedIconString;
    /**
     * Extract class and name from icon name, if the name follows format "{className}:{fontName}".
     * className and fontName can be escaped using \ if : is needed.
     */
    private extractIconClassAndName;
    /**
     * Render image as provided webfont icon.
     * Defaults to ui-core icon if iconName does not contain className.
     */
    private renderWebfontIcon;
    /** Render image from data provided by an image loader */
    render(loadedImage: Image): React.ReactNode;
}
//# sourceMappingURL=ImageRenderer.d.ts.map