"use strict";
/*---------------------------------------------------------------------------------------------
* Copyright (c) Bentley Systems, Incorporated. All rights reserved.
* See LICENSE.md in the project root for license terms and full copyright notice.
*--------------------------------------------------------------------------------------------*/
/** @packageDocumentation
 * @module Common
 */
Object.defineProperty(exports, "__esModule", { value: true });
exports.StandardTypeConverterTypeNames = exports.StandardTypeNames = void 0;
// cSpell:ignore shortdate
/**
 * Standard Type Names for converters and editors.
 * @beta
 * @deprecated Use [[StandardTypeNames]] in ui-abstract instead
 */
var StandardTypeNames;
(function (StandardTypeNames) {
    StandardTypeNames["Text"] = "text";
    StandardTypeNames["String"] = "string";
    StandardTypeNames["ShortDate"] = "shortdate";
    StandardTypeNames["DateTime"] = "dateTime";
    StandardTypeNames["Boolean"] = "boolean";
    StandardTypeNames["Bool"] = "bool";
    StandardTypeNames["Float"] = "float";
    StandardTypeNames["Double"] = "double";
    StandardTypeNames["Int"] = "int";
    StandardTypeNames["Integer"] = "integer";
    StandardTypeNames["Number"] = "number";
    StandardTypeNames["Hexadecimal"] = "hexadecimal";
    StandardTypeNames["Hex"] = "hex";
    StandardTypeNames["Enum"] = "enum";
    StandardTypeNames["Point2d"] = "point2d";
    StandardTypeNames["Point3d"] = "point3d";
    StandardTypeNames["Navigation"] = "navigation";
    StandardTypeNames["Composite"] = "composite";
    StandardTypeNames["Array"] = "array";
    StandardTypeNames["Struct"] = "struct";
})(StandardTypeNames = exports.StandardTypeNames || (exports.StandardTypeNames = {}));
/**
 * StandardTypeConverterTypeNames.
 * @beta
 * @deprecated Use [[StandardTypeNames]] in ui-abstract instead
 */
var StandardTypeConverterTypeNames;
(function (StandardTypeConverterTypeNames) {
    StandardTypeConverterTypeNames["Text"] = "text";
    StandardTypeConverterTypeNames["String"] = "string";
    StandardTypeConverterTypeNames["ShortDate"] = "shortdate";
    StandardTypeConverterTypeNames["DateTime"] = "dateTime";
    StandardTypeConverterTypeNames["Boolean"] = "boolean";
    StandardTypeConverterTypeNames["Bool"] = "bool";
    StandardTypeConverterTypeNames["Float"] = "float";
    StandardTypeConverterTypeNames["Double"] = "double";
    StandardTypeConverterTypeNames["Int"] = "int";
    StandardTypeConverterTypeNames["Integer"] = "integer";
    StandardTypeConverterTypeNames["Hexadecimal"] = "hexadecimal";
    StandardTypeConverterTypeNames["Hex"] = "hex";
    StandardTypeConverterTypeNames["Enum"] = "enum";
    StandardTypeConverterTypeNames["Point2d"] = "point2d";
    StandardTypeConverterTypeNames["Point3d"] = "point3d";
    StandardTypeConverterTypeNames["Navigation"] = "navigation";
    StandardTypeConverterTypeNames["Composite"] = "composite";
})(StandardTypeConverterTypeNames = exports.StandardTypeConverterTypeNames || (exports.StandardTypeConverterTypeNames = {}));
//# sourceMappingURL=StandardTypeNames.js.map