/**
 * Custom hook for working with promise values.
 * Promises are debounced using trailing and leading edge.
 * The first promise will always be executed.
 * Any promises following the first while it is executing will be scheduled (and unscheduled), leaving only the last promise to be resolved.
 * Once the first promise finishes resolving, the last passed promise starts resolving.
 * @alpha
 */
export declare function useDebouncedAsyncValue<TReturn>(valueToBeResolved: undefined | (() => Promise<TReturn>)): {
    value: TReturn | undefined;
    inProgress: boolean;
};
//# sourceMappingURL=UseDebouncedAsyncValue.d.ts.map