/** @internal */
interface RerenderData<T extends (arg: any) => void> {
    /** Data specific to the current rerender cycle. */
    rerenderContext: Parameters<T>[0];
    /** Identifies the current rerender cycle. Starts at 0. */
    numRerenders: number;
    /** Rerenders component with new `rerenderContext`, if one is provided. */
    rerender: T;
}
/**
 * @internal
 * Makes component able to rerender itself.
 */
export declare function useRerender(): RerenderData<() => void>;
/**
 * @internal
 * Makes component able to rerender itself while preserving some data between rerenders.
 * @param initialContext Data that component receives on first render cycle.
 */
export declare function useRerender<T>(initialContext: T): RerenderData<(newContext: T) => void>;
export {};
//# sourceMappingURL=UseRerender.d.ts.map