"use strict";
/*---------------------------------------------------------------------------------------------
* Copyright (c) Bentley Systems, Incorporated. All rights reserved.
* See LICENSE.md in the project root for license terms and full copyright notice.
*--------------------------------------------------------------------------------------------*/
/** @packageDocumentation
 * @module Common
 */
Object.defineProperty(exports, "__esModule", { value: true });
exports.getPropertyRecordAsString = void 0;
const ui_abstract_1 = require("@bentley/ui-abstract");
/**
 * @internal
 * @deprecated The function attempts to return a string representation of `PropertyRecord` which is not always
 * valid. Instead, `PropertyValueRendererManager` should be used to render PropertyRecords.
 */
// istanbul ignore next
function getPropertyRecordAsString(label) {
    var _a;
    if (label.value.valueFormat === ui_abstract_1.PropertyValueFormat.Primitive)
        return (_a = label.value.displayValue) !== null && _a !== void 0 ? _a : "";
    return "";
}
exports.getPropertyRecordAsString = getPropertyRecordAsString;
//# sourceMappingURL=getPropertyRecordAsString.js.map