/** @packageDocumentation
 * @module TypeConverters
 */
import { Primitives } from "@bentley/ui-abstract";
import { TypeConverter } from "./TypeConverter";
/** Boolean Type Converter.
 * @public
 */
export declare class BooleanTypeConverter extends TypeConverter {
    /** @internal */
    static sl10nTrue: string;
    /** @internal */
    static sl10nFalse: string;
    /** @internal */
    static getLocalizedTrueFalse(): void;
    convertToString(value?: Primitives.Boolean): string;
    convertFromString(value: string): boolean;
    sortCompare(a: Primitives.Boolean, b: Primitives.Boolean, _ignoreCase?: boolean): number;
    get isBooleanType(): boolean;
}
//# sourceMappingURL=BooleanTypeConverter.d.ts.map