"use strict";
/*---------------------------------------------------------------------------------------------
* Copyright (c) Bentley Systems, Incorporated. All rights reserved.
* See LICENSE.md in the project root for license terms and full copyright notice.
*--------------------------------------------------------------------------------------------*/
/**
 * @packageDocumentation
 * @module TypeConverters
 */
Object.defineProperty(exports, "__esModule", { value: true });
exports.NavigationPropertyTypeConverter = void 0;
const ui_abstract_1 = require("@bentley/ui-abstract");
const TypeConverter_1 = require("./TypeConverter");
const TypeConverterManager_1 = require("./TypeConverterManager");
/**
 * Navigation property type converter.
 * @public
 */
class NavigationPropertyTypeConverter extends TypeConverter_1.TypeConverter {
    convertPropertyToString(propertyDescription, value) {
        return value === undefined ? "" : propertyDescription.displayLabel;
    }
    sortCompare(a, b, ignoreCase) {
        return TypeConverterManager_1.TypeConverterManager
            .getConverter(ui_abstract_1.StandardTypeNames.Hexadecimal)
            .sortCompare(a.id, b.id, ignoreCase);
    }
}
exports.NavigationPropertyTypeConverter = NavigationPropertyTypeConverter;
TypeConverterManager_1.TypeConverterManager.registerConverter(ui_abstract_1.StandardTypeNames.Navigation, NavigationPropertyTypeConverter);
//# sourceMappingURL=NavigationPropertyTypeConverter.js.map