/** @packageDocumentation
 * @module TypeConverters
 */
import { TypeConverter } from "./TypeConverter";
/**
 * Manages Type Converters. Type Converters are registered with and obtained from the manager.
 * @public
 */
export declare class TypeConverterManager {
    private static _converters;
    private static _defaultTypeConverter;
    private static getFullConverterName;
    static registerConverter(typename: string, converter: new () => TypeConverter, converterName?: string): void;
    static unregisterConverter(typename: string, converterName?: string): void;
    static getConverter(typename: string, converterName?: string): TypeConverter;
}
//# sourceMappingURL=TypeConverterManager.d.ts.map