/** @packageDocumentation
 * @module TypeConverters
 */
import { Id64String } from "@bentley/bentleyjs-core";
/** Converted Primitives namespace
 * @public
 */
export declare namespace ConvertedPrimitives {
    /** Interface for 2d Point
     * @public
     */
    interface Point2d {
        x: number;
        y: number;
    }
    /** Interface for 3d Point
     * @public
     */
    interface Point3d extends Point2d {
        z: number;
    }
    /** Type definition for 2d or 3d Point
     * @public
     */
    type Point = Point2d | Point3d;
    /** Type definition for Value
     * @public
     */
    type Value = boolean | number | string | Date | Point | Id64String;
}
//# sourceMappingURL=ConvertedTypes.d.ts.map