/** @packageDocumentation
 * @module Date
 */
import "./DatePicker.scss";
/**
 * Props for [[DatePicker]] component.
 * @alpha
 */
export interface DatePickerProps {
    /** defines both date and time */
    selected: Date;
    /** function to call when date or time has changed */
    onDateChange?: (day: Date) => void;
    /** show focus outlines, useful for keyboard navigation */
    showFocusOutline?: boolean;
}
/** DatePicker component. Show a month selector and a day calendar to select a specific date.
 * @alpha
 */
export declare function DatePicker(props: DatePickerProps): JSX.Element;
//# sourceMappingURL=DatePicker.d.ts.map