/** @packageDocumentation
 * @module Date
 */
import * as React from "react";
import { DateFormatter, TimeDisplay } from "@bentley/ui-abstract";
import { CommonProps } from "@bentley/ui-core";
import "./DatePickerPopupButton.scss";
/** Props used by [[DatePickerPopupButton]] component.
 * @alpha */
export interface DatePickerPopupButtonProps extends CommonProps {
    /** Date to be shown as the selected date. */
    selected: Date;
    /** If true show the date (and optionally time) edit field next to button */
    displayEditField?: boolean;
    timeDisplay?: TimeDisplay;
    /** Function called when Date changes. */
    onDateChange?: (day: Date) => void;
    /** Optional tooltip */
    buttonToolTip?: string;
    dateFormatter?: DateFormatter;
    /** User defined class name for edit field. */
    fieldClassName?: string;
    /** User defined style for edit field. */
    fieldStyle?: React.CSSProperties;
}
/** Component that displays a button used to pick a date and optionally a time.
 * @alpha
 * */
export declare function DatePickerPopupButton({ displayEditField, timeDisplay, selected, onDateChange, dateFormatter, buttonToolTip, fieldStyle, fieldClassName, style }: DatePickerPopupButtonProps): JSX.Element;
//# sourceMappingURL=DatePickerPopupButton.d.ts.map