/** @packageDocumentation
 * @module Date
 */
import { DateFormatter } from "@bentley/ui-abstract";
/**
 * A basic class that allows user to provide an Intl.DateTimeFormat
 * that can be used to format the date and time display. If no format is
 * specified a default format will be used. This default implementation does not
 * support parsing, so when used by [[DatePickerPopup]] the edit field will be readonly. If
 * a parseData function is implemented then the edit field will be editable.
 * @alpha
 */
export declare class IntlFormatter implements DateFormatter {
    private _intlFormatter?;
    constructor(_intlFormatter?: Intl.DateTimeFormat | undefined);
    get formatter(): Intl.DateTimeFormat;
    formateDate(day: Date): string;
}
//# sourceMappingURL=IntlFormatter.d.ts.map