/** @packageDocumentation
 * @module Date
 */
import { TimeDisplay } from "@bentley/ui-abstract";
import "./TimeField.scss";
/** Interface used to hold 24 hour time in
 * hours, minutes, and seconds.
 * @internal
 */
export interface TimeSpec {
    hours: number;
    minutes: number;
    seconds: number;
}
/** Interface for props used by [[TimeField]] component.
 * @internal
 */
export interface TimeFieldProps {
    time: TimeSpec;
    timeDisplay: TimeDisplay;
    onTimeChange?: (time: TimeSpec) => void;
    readOnly?: boolean;
}
/** Field used to set the Hour:Minutes:Seconds in the [[DatePicker]] Popup panel. The user may key-in the value or use up/down keys to
 * change the time.
 * @internal
 */
export declare function TimeField({ time, timeDisplay, readOnly, onTimeChange }: TimeFieldProps): JSX.Element;
//# sourceMappingURL=TimeField.d.ts.map