/** @packageDocumentation
 * @module DragDrop
 */
import * as React from "react";
import { ConnectDragPreview, ConnectDragSource, DndComponentClass } from "react-dnd";
import { DragSourceProps, DropEffects } from "./DragDropDef";
/** React properties for withDragSource Higher-Order Component
 * @beta
 * @deprecated
 */
export interface WithDragSourceProps<DragDropObject = any> {
    /** Properties and callbacks for DragSource. */
    dragProps: DragSourceProps<DragDropObject>;
    /** Style properties for dropTarget wrapper element */
    dragStyle?: React.CSSProperties;
    /** Which dropEffect dragSource should default to. */
    defaultDropEffect?: DropEffects;
    /** Which dropEffect dragSource should be used when ctrl button is pressed during start of drag. */
    ctrlDropEffect?: DropEffects;
    /** Which dropEffect dragSource should be used when alt button is pressed during start of drag. */
    altDropEffect?: DropEffects;
    /** @internal */
    connectDragSource?: ConnectDragSource;
    /** @internal */
    connectDragPreview?: ConnectDragPreview;
    /** @internal */
    isDragging?: boolean;
    /** @internal */
    canDrag?: boolean;
    /** @internal */
    item?: DragDropObject;
    /** @internal */
    type?: string | symbol | null;
}
/**
 * HOC (Higher-Order Component) that transforms wrapped component into a DragSource.
 * @param Component component to wrap.
 * @beta
 * @deprecated
 */
export declare const withDragSource: <ComponentProps extends {}, DragDropObject = any>(Component: React.ComponentType<ComponentProps>) => DndComponentClass<typeof React.Component, ComponentProps & WithDragSourceProps<DragDropObject>>;
//# sourceMappingURL=withDragSource.d.ts.map