/** @packageDocumentation
 * @module DragDrop
 */
import * as React from "react";
import { ConnectDropTarget, DndComponentClass } from "react-dnd";
import { DropTargetProps } from "./DragDropDef";
/** React properties for withDropTarget Higher-Order Component
 * @beta
 * @deprecated
 */
export interface WithDropTargetProps<DragDropObject = any> {
    /** Properties and callbacks for DropTarget */
    dropProps: DropTargetProps<DragDropObject>;
    /** Whether to propagate to parent DropTargets. */
    shallow?: boolean;
    /** Style properties for dropTarget wrapper element */
    dropStyle?: React.CSSProperties;
    /** @internal */
    connectDropTarget?: ConnectDropTarget;
    /** @internal */
    isOver?: boolean;
    /** @internal */
    canDrop?: boolean;
    /** @internal */
    item?: DragDropObject;
    /** @internal */
    type?: string | symbol;
}
/**
 * HOC (Higher-Order Component) that transforms wrapped component into a DropTarget.
 * @param Component component to wrap.
 * @beta
 * @deprecated
 */
export declare const withDropTarget: <ComponentProps extends {}, DragDropObject = any>(Component: React.ComponentType<ComponentProps>) => DndComponentClass<typeof React.Component, ComponentProps & WithDropTargetProps<DragDropObject>>;
//# sourceMappingURL=withDropTarget.d.ts.map