"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.withDropTarget = void 0;
/*---------------------------------------------------------------------------------------------
* Copyright (c) Bentley Systems, Incorporated. All rights reserved.
* See LICENSE.md in the project root for license terms and full copyright notice.
*--------------------------------------------------------------------------------------------*/
/** @packageDocumentation
 * @module DragDrop
 */
const React = __importStar(require("react"));
const react_dnd_1 = require("react-dnd");
/**
 * HOC (Higher-Order Component) that transforms wrapped component into a DropTarget.
 * @param Component component to wrap.
 * @beta
 * @deprecated
 */
// istanbul ignore next
const withDropTarget = (
// eslint-disable-next-line @typescript-eslint/naming-convention
Component) => {
    return react_dnd_1.DropTarget((props) => {
        if (props.dropProps.objectTypes) {
            if (typeof props.dropProps.objectTypes === "function")
                return props.dropProps.objectTypes();
            else
                return props.dropProps.objectTypes;
        }
        return [];
    }, {
        drop(props, monitor, component) {
            const dragSourceArgs = monitor.getItem(); // eslint-disable-line deprecation/deprecation
            if (monitor.isOver({ shallow: props.shallow || false })) {
                let dropRect = {};
                const componentElement = component.rootElement;
                if (componentElement) {
                    dropRect = componentElement.getBoundingClientRect();
                }
                const clientOffset = monitor.getClientOffset() || dragSourceArgs.clientOffset;
                const initialClientOffset = monitor.getInitialClientOffset() || dragSourceArgs.initialClientOffset;
                const sourceClientOffset = monitor.getSourceClientOffset() || dragSourceArgs.sourceClientOffset;
                const initialSourceClientOffset = monitor.getInitialSourceClientOffset() || dragSourceArgs.initialSourceClientOffset;
                const dropTargetArgs = Object.assign(Object.assign({}, dragSourceArgs), { row: undefined, col: undefined, dropRect,
                    clientOffset,
                    initialClientOffset,
                    sourceClientOffset,
                    initialSourceClientOffset });
                if (props.dropProps.onDropTargetDrop)
                    return props.dropProps.onDropTargetDrop(dropTargetArgs);
            }
            return;
        },
        hover(props, monitor, component) {
            if (monitor.isOver({ shallow: props.shallow || false }) && props.dropProps.onDropTargetOver) {
                const dragSourceArgs = monitor.getItem(); // eslint-disable-line deprecation/deprecation
                let dropRect = {};
                const componentElement = component.rootElement;
                if (componentElement) {
                    dropRect = componentElement.getBoundingClientRect();
                }
                const clientOffset = monitor.getClientOffset() || dragSourceArgs.clientOffset;
                const initialClientOffset = monitor.getInitialClientOffset() || dragSourceArgs.initialClientOffset;
                const sourceClientOffset = monitor.getSourceClientOffset() || dragSourceArgs.sourceClientOffset;
                const initialSourceClientOffset = monitor.getInitialSourceClientOffset() || dragSourceArgs.initialSourceClientOffset;
                const dropTargetArgs = Object.assign(Object.assign({}, dragSourceArgs), { row: undefined, col: undefined, dropRect,
                    clientOffset,
                    initialClientOffset,
                    sourceClientOffset,
                    initialSourceClientOffset });
                props.dropProps.onDropTargetOver(dropTargetArgs);
            }
        },
        canDrop(props, monitor) {
            if (monitor.isOver({ shallow: props.shallow || false }) && props.dropProps.canDropTargetDrop) {
                const dragSourceArgs = monitor.getItem(); // eslint-disable-line deprecation/deprecation
                const clientOffset = monitor.getClientOffset() || dragSourceArgs.clientOffset;
                const initialClientOffset = monitor.getInitialClientOffset() || dragSourceArgs.initialClientOffset;
                const sourceClientOffset = monitor.getSourceClientOffset() || dragSourceArgs.sourceClientOffset;
                const initialSourceClientOffset = monitor.getInitialSourceClientOffset() || dragSourceArgs.initialSourceClientOffset;
                const dropTargetArgs = Object.assign(Object.assign({}, dragSourceArgs), { clientOffset,
                    initialClientOffset,
                    sourceClientOffset,
                    initialSourceClientOffset });
                return props.dropProps.canDropTargetDrop(dropTargetArgs);
            }
            return true;
        },
    }, (connect, monitor) => {
        return {
            connectDropTarget: connect.dropTarget(),
            isOver: monitor.isOver({ shallow: true }),
            canDrop: monitor.canDrop(),
            item: monitor.getItem(),
            type: monitor.getItemType() || undefined,
        };
    })(class WithDropTarget extends React.Component {
        constructor() {
            super(...arguments);
            this.rootElement = null;
        }
        render() {
            const _a = this.props, { dropProps, shallow, // eslint-disable-line @typescript-eslint/no-unused-vars
            connectDropTarget, isOver, canDrop, item, type, dropStyle } = _a, // eslint-disable-line @typescript-eslint/no-unused-vars
            props = __rest(_a, ["dropProps", "shallow", "connectDropTarget", "isOver", "canDrop", "item", "type", "dropStyle"]); // eslint-disable-line deprecation/deprecation
            const p = {
                item,
                type,
                isOver,
                canDrop,
            };
            return connectDropTarget(React.createElement("div", { className: "drop-target-wrapper", "data-testid": "drop-target-wrapper", ref: (el) => { this.rootElement = el; }, style: this.props.dropStyle },
                React.createElement(Component, Object.assign({}, props, p))));
        }
    });
};
exports.withDropTarget = withDropTarget;
//# sourceMappingURL=withDropTarget.js.map