/** @packageDocumentation
 * @module PropertyEditors
 */
import "./BooleanEditor.scss";
import * as React from "react";
import { PropertyValue } from "@bentley/ui-abstract";
import { PropertyEditorProps, TypeEditor } from "./EditorContainer";
import { PropertyEditorBase } from "./PropertyEditorManager";
/** @internal */
interface BooleanEditorState {
    checkboxValue: boolean;
    isDisabled?: boolean;
}
/** BooleanEditor React component that is a property editor with checkbox input
 * @beta
 */
export declare class BooleanEditor extends React.PureComponent<PropertyEditorProps, BooleanEditorState> implements TypeEditor {
    private _isMounted;
    private _inputElement;
    /** @internal */
    readonly state: Readonly<BooleanEditorState>;
    getPropertyValue(): Promise<PropertyValue | undefined>;
    get htmlElement(): HTMLElement | null;
    get hasFocus(): boolean;
    private _updateCheckboxValue;
    /** @internal */
    componentDidMount(): void;
    /** @internal */
    componentWillUnmount(): void;
    /** @internal */
    componentDidUpdate(prevProps: PropertyEditorProps): void;
    private setStateFromProps;
    /** @internal */
    render(): JSX.Element;
}
/** Boolean Property Editor registered for the "bool" and "boolean" type names.
 * It uses the [[BooleanEditor]] React component.
 * @beta
 */
export declare class BooleanPropertyEditor extends PropertyEditorBase {
    get reactNode(): React.ReactNode;
}
export {};
//# sourceMappingURL=BooleanEditor.d.ts.map