/** @packageDocumentation
 * @module PropertyEditors
 */
import "./ColorEditor.scss";
import * as React from "react";
import { ColorDef } from "@bentley/imodeljs-common";
import { PropertyValue } from "@bentley/ui-abstract";
import { PropertyEditorProps, TypeEditor } from "./EditorContainer";
import { PropertyEditorBase } from "./PropertyEditorManager";
/** @internal */
interface ColorEditorState {
    colorValue: number;
    readonly: boolean;
    isDisabled?: boolean;
    numColumns: number;
    availableColors: ColorDef[];
}
/** ColorEditor React component that is a property editor with text input
 * @beta
 */
export declare class ColorEditor extends React.PureComponent<PropertyEditorProps, ColorEditorState> implements TypeEditor {
    private _buttonElement;
    /** @internal */
    readonly state: Readonly<ColorEditorState>;
    getPropertyValue(): Promise<PropertyValue | undefined>;
    get htmlElement(): HTMLElement | null;
    get hasFocus(): boolean;
    private setFocus;
    private _onColorPick;
    /** @internal */
    componentDidMount(): void;
    /** @internal */
    componentDidUpdate(prevProps: PropertyEditorProps): void;
    private setStateFromProps;
    /** @internal */
    render(): JSX.Element;
}
/** Color Property Editor registered for the "number" type name and "color-picker" editor name.
 * It uses the [[ColorEditor]] React component.
 * @beta
 */
export declare class ColorPropertyEditor extends PropertyEditorBase {
    get reactNode(): React.ReactNode;
}
export {};
//# sourceMappingURL=ColorEditor.d.ts.map