/** @packageDocumentation
 * @module PropertyEditors
 */
import "./EnumButtonGroupEditor.scss";
import * as React from "react";
import { EnumerationChoice, IconDefinition, PropertyValue } from "@bentley/ui-abstract";
import { PropertyEditorProps, TypeEditor } from "./EditorContainer";
import { PropertyEditorBase } from "./PropertyEditorManager";
/** @internal */
interface EnumButtonGroupEditorState {
    selectValue: string | number;
    enumIcons: IconDefinition[];
    choices: EnumerationChoice[];
}
/** EnumButtonGroupEditor React component that is a property editor with select input
 * @beta
 */
export declare class EnumButtonGroupEditor extends React.Component<PropertyEditorProps, EnumButtonGroupEditorState> implements TypeEditor {
    private _btnRefs;
    private _divElement;
    /** @internal */
    readonly state: Readonly<EnumButtonGroupEditorState>;
    getPropertyValue(): Promise<PropertyValue | undefined>;
    get htmlElement(): HTMLElement | null;
    get hasFocus(): boolean;
    /** @internal */
    componentDidMount(): void;
    /** @internal */
    componentDidUpdate(prevProps: PropertyEditorProps): void;
    private setStateFromProps;
    private _handleButtonClick;
    private getButton;
    /** @internal */
    render(): JSX.Element;
}
/** Enum Property Button Group Editor registered for the "enum" type name and the "enum-buttongroup" editor name.
 * It uses the [[EnumButtonGroupEditor]] React component.
 * @beta
 */
export declare class EnumPropertyButtonGroupEditor extends PropertyEditorBase {
    get reactNode(): React.ReactNode;
}
export {};
//# sourceMappingURL=EnumButtonGroupEditor.d.ts.map