/** @packageDocumentation
 * @module PropertyEditors
 */
import "./EnumEditor.scss";
import * as React from "react";
import { PropertyValue } from "@bentley/ui-abstract";
import { PropertyEditorProps, TypeEditor } from "./EditorContainer";
import { PropertyEditorBase } from "./PropertyEditorManager";
/** @internal */
interface EnumEditorState {
    selectValue: string | number;
    valueIsNumber: boolean;
    options: {
        [key: string]: string;
    };
}
/** EnumEditor React component that is a property editor with select input
 * @beta
 */
export declare class EnumEditor extends React.PureComponent<PropertyEditorProps, EnumEditorState> implements TypeEditor {
    private _isMounted;
    private _ariaLabel;
    private _selectElement;
    /** @internal */
    readonly state: Readonly<EnumEditorState>;
    getPropertyValue(): Promise<PropertyValue | undefined>;
    get htmlElement(): HTMLElement | null;
    get hasFocus(): boolean;
    private _updateSelectValue;
    /** @internal */
    componentDidMount(): void;
    /** @internal */
    componentWillUnmount(): void;
    /** @internal */
    componentDidUpdate(prevProps: PropertyEditorProps): void;
    private setStateFromProps;
    /** @internal */
    render(): JSX.Element;
}
/** Enum Property Button Group Editor registered for the "enum" type name.
 * It uses the [[EnumEditor]] React component.
 * @beta
 */
export declare class EnumPropertyEditor extends PropertyEditorBase {
    get containerHandlesEnter(): boolean;
    get reactNode(): React.ReactNode;
}
export {};
//# sourceMappingURL=EnumEditor.d.ts.map