/** @packageDocumentation
 * @module PropertyEditors
 */
import "./IconEditor.scss";
import * as React from "react";
import { PropertyValue } from "@bentley/ui-abstract";
import { PropertyEditorProps, TypeEditor } from "./EditorContainer";
import { PropertyEditorBase } from "./PropertyEditorManager";
/** @internal */
interface IconEditorState {
    icon: string;
    icons: string[];
    numColumns: number;
    readonly?: boolean;
    isDisabled?: boolean;
}
/** IconEditor React component that is a property editor with button and popup
 * @alpha
 */
export declare class IconEditor extends React.PureComponent<PropertyEditorProps, IconEditorState> implements TypeEditor {
    private _control;
    private _isMounted;
    private _divElement;
    constructor(props: PropertyEditorProps);
    getPropertyValue(): Promise<PropertyValue | undefined>;
    get htmlElement(): HTMLElement | null;
    get hasFocus(): boolean;
    private setFocus;
    private _onIconChange;
    /** @internal */
    componentDidMount(): void;
    /** @internal */
    componentWillUnmount(): void;
    /** @internal */
    componentDidUpdate(prevProps: PropertyEditorProps): void;
    private setStateFromProps;
    /** @internal */
    render(): JSX.Element;
}
/** Icon Property Editor registered for the "text" and "string" type names and the "icon-picker" editor name.
 * It uses the [[IconEditor]] React component.
 * @alpha
 */
export declare class IconPropertyEditor extends PropertyEditorBase {
    get reactNode(): React.ReactNode;
}
export {};
//# sourceMappingURL=IconEditor.d.ts.map