/** @packageDocumentation
 * @module PropertyEditors
 */
import "./ImageCheckBoxEditor.scss";
import * as React from "react";
import { PropertyValue } from "@bentley/ui-abstract";
import { PropertyEditorProps, TypeEditor } from "./EditorContainer";
import { PropertyEditorBase } from "./PropertyEditorManager";
/** @internal */
interface ImageCheckBoxEditorState {
    /** Image for the "checked" state */
    imageOn: string;
    /** Image for the "unchecked" (default) state */
    imageOff: string;
    checkboxValue: boolean;
    isDisabled?: boolean;
}
/** [[ImageCheckBoxEditor]]
 * Boolean editor that renders with an image instead of checkbox
 * @beta
 */
export declare class ImageCheckBoxEditor extends React.PureComponent<PropertyEditorProps, ImageCheckBoxEditorState> implements TypeEditor {
    private _isMounted;
    private _inputElement;
    /** @internal */
    readonly state: Readonly<ImageCheckBoxEditorState>;
    getPropertyValue(): Promise<PropertyValue | undefined>;
    get htmlElement(): HTMLElement | null;
    get hasFocus(): boolean;
    /** @internal */
    componentDidMount(): void;
    /** @internal */
    componentWillUnmount(): void;
    /** @internal */
    componentDidUpdate(prevProps: PropertyEditorProps): void;
    private setStateFromProps;
    private _handleClick;
    render(): JSX.Element;
}
/** ImageCheckBox Property Editor registered for the "bool" and "boolean" type names.
 * It uses the [[ImageCheckBoxEditor]] React component.
 * @beta
 */
export declare class ImageCheckBoxPropertyEditor extends PropertyEditorBase {
    get reactNode(): React.ReactNode;
}
export {};
//# sourceMappingURL=ImageCheckBoxEditor.d.ts.map