/** @packageDocumentation
 * @module PropertyEditors
 */
import "./NumericInputEditor.scss";
import * as React from "react";
import { PropertyValue } from "@bentley/ui-abstract";
import { PropertyEditorProps, TypeEditor } from "./EditorContainer";
import { PropertyEditorBase } from "./PropertyEditorManager";
/** @internal */
interface NumericInputEditorState {
    value: number;
    readonly: boolean;
    isDisabled?: boolean;
    size?: number;
    maxLength?: number;
    min?: number;
    max?: number;
    step?: number;
    precision?: number;
}
/** NumericInputEditor React component that is a property editor with numeric input & up/down buttons
 * @beta
 */
export declare class NumericInputEditor extends React.PureComponent<PropertyEditorProps, NumericInputEditorState> implements TypeEditor {
    private _isMounted;
    private _inputElement;
    hasFocus: boolean;
    /** @internal */
    readonly state: Readonly<NumericInputEditorState>;
    getPropertyValue(): Promise<PropertyValue | undefined>;
    get htmlElement(): HTMLElement | null;
    private _handleCommit;
    private _updateValue;
    /** @internal */
    componentDidMount(): void;
    /** @internal */
    componentWillUnmount(): void;
    /** @internal */
    componentDidUpdate(prevProps: PropertyEditorProps): void;
    private setStateFromProps;
    /** @internal */
    render(): React.ReactNode;
}
/** Numeric Input Property Editor registered for the "number" type name and "numeric-input" editor name.
 * It uses the [[NumericInputEditor]] React component.
 * @beta
 */
export declare class NumericInputPropertyEditor extends PropertyEditorBase {
    get reactNode(): React.ReactNode;
    get containerHandlesEnter(): boolean;
}
export {};
//# sourceMappingURL=NumericInputEditor.d.ts.map