/** @packageDocumentation
 * @module PropertyEditors
 */
import "./TextEditor.scss";
import * as React from "react";
import { PropertyValue } from "@bentley/ui-abstract";
import { PropertyEditorProps, TypeEditor } from "./EditorContainer";
/** @internal */
interface TextEditorState {
    inputValue: string;
    readonly: boolean;
    isDisabled?: boolean;
    size?: number;
    maxLength?: number;
    iconSpec?: string;
}
/** TextEditor React component that is a property editor with text input
 * @beta
 */
export declare class TextEditor extends React.PureComponent<PropertyEditorProps, TextEditorState> implements TypeEditor {
    private _isMounted;
    private _ariaLabel;
    private _inputElement;
    /** @internal */
    readonly state: Readonly<TextEditorState>;
    getPropertyValue(): Promise<PropertyValue | undefined>;
    get htmlElement(): HTMLElement | null;
    get hasFocus(): boolean;
    private _updateInputValue;
    /** @internal */
    componentDidMount(): void;
    /** @internal */
    componentWillUnmount(): void;
    /** @internal */
    componentDidUpdate(prevProps: PropertyEditorProps): void;
    private setStateFromProps;
    /** @internal */
    render(): React.ReactNode;
}
export {};
//# sourceMappingURL=TextEditor.d.ts.map