/** @packageDocumentation
 * @module PropertyEditors
 */
import "./ToggleEditor.scss";
import * as React from "react";
import { PropertyValue } from "@bentley/ui-abstract";
import { PropertyEditorProps, TypeEditor } from "./EditorContainer";
import { PropertyEditorBase } from "./PropertyEditorManager";
/** @internal */
interface ToggleEditorState {
    toggleValue: boolean;
    isDisabled?: boolean;
}
/** ToggleEditor React component that is a property editor with checkbox input
 * @beta
 */
export declare class ToggleEditor extends React.PureComponent<PropertyEditorProps, ToggleEditorState> implements TypeEditor {
    private _isMounted;
    private _inputElement;
    /** @internal */
    readonly state: Readonly<ToggleEditorState>;
    getPropertyValue(): Promise<PropertyValue | undefined>;
    get htmlElement(): HTMLElement | null;
    get hasFocus(): boolean;
    private _updateToggleValue;
    /** @internal */
    componentDidMount(): void;
    /** @internal */
    componentWillUnmount(): void;
    /** @internal */
    componentDidUpdate(prevProps: PropertyEditorProps): void;
    private setStateFromProps;
    /** @internal */
    render(): JSX.Element;
}
/** Toggle Property Editor registered for the "bool" and "boolean" type names and "toggle" editor name.
 * It uses the [[ToggleEditor]] React component.
 * @beta
 */
export declare class TogglePropertyEditor extends PropertyEditorBase {
    get reactNode(): React.ReactNode;
}
export {};
//# sourceMappingURL=ToggleEditor.d.ts.map