/** @packageDocumentation
 * @module PropertyEditors
 */
import "./WeightEditor.scss";
import * as React from "react";
import { PropertyValue } from "@bentley/ui-abstract";
import { PropertyEditorProps, TypeEditor } from "./EditorContainer";
import { PropertyEditorBase } from "./PropertyEditorManager";
/** @internal */
interface WeightEditorState {
    weightValue: number;
    readonly: boolean;
    isDisabled?: boolean;
}
/** WeightEditor React component that is a property editor for picking a weight using a [[WeightPickerButton]] component
 * @beta
 */
export declare class WeightEditor extends React.PureComponent<PropertyEditorProps, WeightEditorState> implements TypeEditor {
    private _control;
    private _isMounted;
    private _availableWeights;
    private _divElement;
    /** @internal */
    readonly state: Readonly<WeightEditorState>;
    constructor(props: PropertyEditorProps);
    getPropertyValue(): Promise<PropertyValue | undefined>;
    get htmlElement(): HTMLElement | null;
    get hasFocus(): boolean;
    private setFocus;
    private _onLineWeightPick;
    /** @internal */
    componentDidMount(): void;
    /** @internal */
    componentWillUnmount(): void;
    /** @internal */
    componentDidUpdate(prevProps: PropertyEditorProps): void;
    private setStateFromProps;
    /** @internal */
    render(): JSX.Element;
}
/** Weight Property Editor registered for the "number" type name and "weight-picker" editor name.
 * It uses the [[WeightEditor]] React component.
 * @beta
 */
export declare class WeightPropertyEditor extends PropertyEditorBase {
    get reactNode(): React.ReactNode;
}
export {};
//# sourceMappingURL=WeightEditor.d.ts.map