"use strict";
/*---------------------------------------------------------------------------------------------
* Copyright (c) Bentley Systems, Incorporated. All rights reserved.
* See LICENSE.md in the project root for license terms and full copyright notice.
*--------------------------------------------------------------------------------------------*/
/** @packageDocumentation
 * @module Favorite
 */
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.FavoritePropertiesRenderer = void 0;
const React = __importStar(require("react"));
const ReactDOM = __importStar(require("react-dom"));
const FavoritePropertyList_1 = require("./FavoritePropertyList");
/** Renderer for Favorite Property List
 * @beta
 */
class FavoritePropertiesRenderer {
    hasFavorites(propertyData) {
        return propertyData.records.Favorite !== undefined;
    }
    renderFavorites(propertyData, orientation) {
        const div = document.createElement("div");
        ReactDOM.render(React.createElement(FavoritePropertyList_1.FavoritePropertyList, { propertyData, orientation }, null), div);
        return div;
    }
}
exports.FavoritePropertiesRenderer = FavoritePropertiesRenderer;
//# sourceMappingURL=FavoritePropertiesRenderer.js.map