"use strict";
/*---------------------------------------------------------------------------------------------
* Copyright (c) Bentley Systems, Incorporated. All rights reserved.
* See LICENSE.md in the project root for license terms and full copyright notice.
*--------------------------------------------------------------------------------------------*/
/** @packageDocumentation
 * @module Favorite
 */
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.FavoritePropertyList = void 0;
require("./FavoritePropertyList.scss");
const React = __importStar(require("react"));
const ui_core_1 = require("@bentley/ui-core");
const ValueRendererManager_1 = require("../properties/ValueRendererManager");
const PropertyList_1 = require("../propertygrid/component/PropertyList");
/** Favorite Property List React component
 * @alpha
 */
class FavoritePropertyList extends React.PureComponent {
    /** @internal */
    render() {
        var _a, _b;
        if (this.props.propertyData.records.Favorite !== undefined) {
            const propertyValueRendererManager = (_a = this.props.propertyValueRendererManager) !== null && _a !== void 0 ? _a : ValueRendererManager_1.PropertyValueRendererManager.defaultManager;
            const orientation = (_b = this.props.orientation) !== null && _b !== void 0 ? _b : ui_core_1.Orientation.Horizontal;
            return (React.createElement("div", { className: "components-favorite-property-list" },
                React.createElement(PropertyList_1.PropertyList, { orientation: orientation, properties: this.props.propertyData.records.Favorite, columnRatio: 1 / 3, propertyValueRendererManager: propertyValueRendererManager })));
        }
        return null;
    }
}
exports.FavoritePropertyList = FavoritePropertyList;
//# sourceMappingURL=FavoritePropertyList.js.map