/** @packageDocumentation
 * @module Filtering
 */
import "./ResultSelector.scss";
import * as React from "react";
import { CommonProps } from "@bentley/ui-core";
/** [[ResultSelector]] React Component state
 * @internal
 */
interface ResultSelectorState {
    /** Currently selected result/entry index */
    selectedResultId: number;
    /** Input string */
    selectedResultEdit: string;
    /** Informs if selectedResult is currently being edited */
    selectedResultInEditMode: boolean;
}
/** [[ResultSelector]] React Component properties
 * @public
 */
export interface ResultSelectorProps extends CommonProps {
    /** Total number of results/entries */
    resultCount: number;
    /** Callback to currently selected result/entry change */
    onSelectedChanged: (index: number) => void;
}
/** Component for stepping through results/entries
 * @public
 */
export declare class ResultSelector extends React.PureComponent<ResultSelectorProps, ResultSelectorState> {
    private _ofLabel;
    /** @internal */
    constructor(props: ResultSelectorProps);
    private _onClickPrevious;
    private _onClickNext;
    private get _maxSelectedResultInputLength();
    private _onSelectedResultChanged;
    private _onSelectedResultConfirmed;
    private _onSelectedResultClick;
    private _onSelectedResultKeyDown;
    /** @internal */
    componentDidMount(): void;
    /** @internal */
    componentDidUpdate(prevProps: ResultSelectorProps): void;
    /** @internal */
    render(): JSX.Element;
}
export {};
//# sourceMappingURL=ResultSelector.d.ts.map