/** @packageDocumentation
 * @module IconPicker
 */
import "./IconPickerButton.scss";
import * as React from "react";
import { CommonProps } from "@bentley/ui-core";
/** Properties for the [[IconPicker]] React component
 * @alpha
 */
export interface IconPickerProps extends React.ButtonHTMLAttributes<HTMLButtonElement>, CommonProps {
    /** active string */
    icon: string;
    /** available icons */
    icons: string[];
    /** function to run when user selects icon */
    onIconChange?: ((icon: string) => void) | undefined;
    /** Disabled or not */
    disabled?: boolean;
    /** Readonly or not */
    readonly?: boolean;
    /** Title to show at top of DropDown */
    dropDownTitle?: string;
    /** Number of columns */
    numColumns: number;
}
/** @internal */
interface IconPickerState {
    showPopup: boolean;
    icon: string;
}
/** IconPickerButton component
 * @alpha
 */
export declare class IconPickerButton extends React.PureComponent<IconPickerProps, IconPickerState> {
    private _target;
    /** @internal */
    static defaultProps: Partial<IconPickerProps>;
    /** @internal */
    constructor(props: IconPickerProps);
    private _togglePopup;
    private _closePopup;
    private _handleIconPicked;
    private renderPopup;
    /** @internal */
    render(): JSX.Element;
}
export {};
//# sourceMappingURL=IconPickerButton.d.ts.map