/** @packageDocumentation
 * @module LineWeight
 */
import "./Swatch.scss";
import * as React from "react";
import { ColorDef } from "@bentley/imodeljs-common";
import { CommonProps } from "@bentley/ui-core";
/** Properties for the [[LineWeightSwatch]] React component
 * @beta
 */
export interface LineWeightSwatchProps extends React.ButtonHTMLAttributes<HTMLButtonElement>, CommonProps {
    /** color specification */
    weight: number;
    /** color specification */
    colorDef?: ColorDef;
    /** hide the weight label */
    hideLabel?: boolean;
    /** Disabled or not */
    disabled?: boolean;
    /** Readonly or not */
    readonly?: boolean;
    /** function to run when user selects a line weight swatch */
    onClick?: () => void;
}
/** LineWeightSwatch Functional component
 * @beta
 */
export declare class LineWeightSwatch extends React.PureComponent<LineWeightSwatchProps> {
    /** @internal */
    constructor(props: LineWeightSwatchProps);
    componentDidMount(): void;
    render(): JSX.Element;
}
//# sourceMappingURL=Swatch.d.ts.map