/** @packageDocumentation
 * @module OIDC
 */
import "./SignIn.scss";
import * as React from "react";
import { CommonProps } from "@bentley/ui-core";
/** Properties for the [[SignIn]] component
 * @public
 */
export interface SignInProps extends CommonProps {
    /** Handler for clicking the Sign-In button */
    onSignIn: () => void;
    /** Handler for clicking the Register link */
    onRegister?: () => void;
    /** Handler for clicking the Offline link */
    onOffline?: () => void;
    /** Disable the signin button after the sign-in process has started. If unspecified defaults to true.
     * @internal
     */
    disableSignInOnClick?: boolean;
    /** Show a message when signing in
     * @internal
     */
    signingInMessage?: string;
}
/** @internal */
interface SignInState {
    isSigningIn: boolean;
    prompt: string;
    signInButton: string;
    profilePrompt: string;
    registerAnchor: string;
    offlineButton: string;
}
/**
 * SignIn React presentational component
 * @public
 */
export declare class SignIn extends React.PureComponent<SignInProps, SignInState> {
    constructor(props: SignInProps);
    private _onSignInClick;
    private _onSigningIn;
    private _handleKeyUp;
    render(): JSX.Element;
}
export {};
//# sourceMappingURL=SignIn.d.ts.map