/** @packageDocumentation
 * @module Properties
 */
import * as React from "react";
import { LinkElementsInfo, PropertyRecord } from "@bentley/ui-abstract";
/** Returns true if property record has an anchor tag
 * @public
 * @deprecated Should check if [[PropertyRecord]] has any links set instead.
 */
export declare const hasLinks: (record: PropertyRecord) => boolean;
/** Renders anchor tag by wrapping or splitting provided text
 * @public
 */
export declare const renderLinks: (text: string, links: LinkElementsInfo, highlight?: ((text: string) => React.ReactNode) | undefined) => React.ReactNode;
/** If record has links, wraps stringValue in them, otherwise returns unchanged stringValue
 * Optionally it can highlight text
 * @public
 */
export declare const withLinks: (stringValue: string, links?: LinkElementsInfo | undefined, highlight?: ((text: string) => React.ReactNode) | undefined) => React.ReactNode;
/**
 * Properties for [[LinksRenderer]] component.
 * @alpha
 */
export interface LinksRendererProps {
    value: string;
    links?: LinkElementsInfo;
    highlighter?: (text: string) => React.ReactNode;
}
/**
 * React component for rendering string with links.
 * @alpha
 */
export declare function LinksRenderer(props: LinksRendererProps): JSX.Element;
//# sourceMappingURL=LinkHandler.d.ts.map