/** @packageDocumentation
 * @module Properties
 */
import "./ActionButtonList.scss";
import * as React from "react";
import { PropertyRecord } from "@bentley/ui-abstract";
import { Orientation } from "@bentley/ui-core";
import { ActionButtonRenderer } from "./ActionButtonRenderer";
/** Properties of [[ActionButtonList]] React component
 * @beta
 */
export interface ActionButtonListProps {
    /** Orientation to use for displaying the action buttons */
    orientation: Orientation;
    /** Property that action buttons belong to */
    property: PropertyRecord;
    /** Array of action button renderers */
    actionButtonRenderers: ActionButtonRenderer[];
    /** Indicated whether a property is hovered  */
    isPropertyHovered?: boolean;
}
/** ActionButtonList React component.
 * @beta
 */
export declare class ActionButtonList extends React.PureComponent<ActionButtonListProps> {
    private getClassName;
    /** @internal */
    render(): JSX.Element;
}
//# sourceMappingURL=ActionButtonList.d.ts.map