"use strict";
/*---------------------------------------------------------------------------------------------
* Copyright (c) Bentley Systems, Incorporated. All rights reserved.
* See LICENSE.md in the project root for license terms and full copyright notice.
*--------------------------------------------------------------------------------------------*/
/** @packageDocumentation
 * @module Properties
 */
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ActionButtonList = void 0;
require("./ActionButtonList.scss");
const React = __importStar(require("react"));
const ui_core_1 = require("@bentley/ui-core");
/** ActionButtonList React component.
 * @beta
 */
class ActionButtonList extends React.PureComponent {
    getClassName(orientation) {
        return orientation === ui_core_1.Orientation.Horizontal
            ? "components-property-action-button-list--horizontal"
            : "components-property-action-button-list--vertical";
    }
    /** @internal */
    render() {
        return (React.createElement("div", { className: this.getClassName(this.props.orientation) }, this.props.actionButtonRenderers.map((renderer, index) => React.createElement(ActionButtonContainer, { key: index, renderer: renderer, rendererProps: {
                property: this.props.property,
                isPropertyHovered: this.props.isPropertyHovered,
            } }))));
    }
}
exports.ActionButtonList = ActionButtonList;
function ActionButtonContainer(props) {
    const actionButton = props.renderer(props.rendererProps);
    if (!actionButton)
        return null;
    return (React.createElement("div", { className: "components-action-button-container" }, actionButton));
}
//# sourceMappingURL=ActionButtonList.js.map