/** @packageDocumentation
 * @module Properties
 */
import * as React from "react";
import { PropertyRecord } from "@bentley/ui-abstract";
import { Orientation } from "@bentley/ui-core";
import { HighlightingComponentProps } from "../../common/HighlightingComponentProps";
import { PropertyValueRendererManager } from "../ValueRendererManager";
/**
 * @internal
 */
export declare class CommonPropertyRenderer {
    static getLabelOffset(indentation?: number, orientation?: Orientation, width?: number, columnRatio?: number, minColumnLabelWidth?: number): number;
    static createNewDisplayValue(orientation: Orientation, propertyRecord: PropertyRecord, indentation?: number, propertyValueRendererManager?: PropertyValueRendererManager, isExpanded?: boolean, onExpansionToggled?: () => void, onHeightChanged?: (newHeight: number) => void, highlight?: HighlightingComponentProps & {
        applyOnLabel: boolean;
        applyOnValue: boolean;
    }): React.ReactNode;
    private static createHighlightCallback;
}
//# sourceMappingURL=CommonPropertyRenderer.d.ts.map