/** @packageDocumentation
 * @module Properties
 */
import "./NonPrimitivePropertyRenderer.scss";
import * as React from "react";
import { PrimitiveRendererProps } from "./PrimitivePropertyRenderer";
/** Properties of [[NonPrimitivePropertyRenderer]] React component
 * @public
 */
export interface NonPrimitivePropertyRendererProps extends PrimitiveRendererProps {
    /** Can struct/array property be collapsed */
    isCollapsible?: boolean;
}
/** State of [[NonPrimitivePropertyRenderer]] React component
 * @internal
 */
interface NonPrimitivePropertyRendererState {
    /** Is struct/array property expanded */
    isExpanded?: boolean;
}
/** React Component that renders struct and array properties
 * @public
 */
export declare class NonPrimitivePropertyRenderer extends React.Component<NonPrimitivePropertyRendererProps, NonPrimitivePropertyRendererState> {
    /** @internal */
    readonly state: NonPrimitivePropertyRendererState;
    constructor(props: NonPrimitivePropertyRendererProps);
    private _onExpanded;
    private _onCollapsed;
    private getLabel;
    private overrideArrayChildrenNames;
    private _renderPropertyForItem;
    /** @internal */
    render(): JSX.Element;
}
export {};
//# sourceMappingURL=NonPrimitivePropertyRenderer.d.ts.map