/** @packageDocumentation
 * @module Properties
 */
import * as React from "react";
import { HighlightingComponentProps } from "../../common/HighlightingComponentProps";
import { SharedRendererProps } from "./PropertyRenderer";
/** Properties of [[PrimitivePropertyRenderer]] React component
 * @public
 */
export interface PrimitiveRendererProps extends SharedRendererProps {
    /** Property value as a React element */
    valueElement?: React.ReactNode;
    /** Render callback for property value. If specified, `valueElement` is ignored. */
    valueElementRenderer?: () => React.ReactNode;
    /** Multiplier of how much the property is indented to the right */
    indentation?: number;
    /** Properties used for highlighting
     * @beta
    */
    highlight?: HighlightingComponentProps;
}
/** React Component that renders primitive properties
 * @public
 */
export declare class PrimitivePropertyRenderer extends React.Component<PrimitiveRendererProps> {
    constructor(props: PrimitiveRendererProps);
    /** @internal */
    render(): JSX.Element;
}
//# sourceMappingURL=PrimitivePropertyRenderer.d.ts.map