"use strict";
/*---------------------------------------------------------------------------------------------
* Copyright (c) Bentley Systems, Incorporated. All rights reserved.
* See LICENSE.md in the project root for license terms and full copyright notice.
*--------------------------------------------------------------------------------------------*/
/** @packageDocumentation
 * @module Properties
 */
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.PrimitivePropertyRenderer = void 0;
const React = __importStar(require("react"));
const ui_core_1 = require("@bentley/ui-core");
const HighlightedText_1 = require("../../common/HighlightedText");
const CommonPropertyRenderer_1 = require("./CommonPropertyRenderer");
const PrimitivePropertyLabelRenderer_1 = require("./label/PrimitivePropertyLabelRenderer");
const PropertyView_1 = require("./PropertyView");
/** React Component that renders primitive properties
 * @public
 */
class PrimitivePropertyRenderer extends React.Component {
    constructor(props) {
        super(props);
    }
    /** @internal */
    render() {
        var _a, _b;
        const _c = this.props, { children, indentation, highlight } = _c, props = __rest(_c, ["children", "indentation", "highlight"]); // eslint-disable-line @typescript-eslint/no-unused-vars
        const displayLabel = this.props.propertyRecord.property.displayLabel;
        const offset = CommonPropertyRenderer_1.CommonPropertyRenderer.getLabelOffset(indentation, props.orientation, props.width, props.columnRatio, (_a = props.columnInfo) === null || _a === void 0 ? void 0 : _a.minLabelWidth);
        const activeMatchIndex = this.props.propertyRecord.property.name === ((_b = highlight === null || highlight === void 0 ? void 0 : highlight.activeHighlight) === null || _b === void 0 ? void 0 : _b.highlightedItemIdentifier) ? highlight.activeHighlight.highlightIndex : undefined;
        const label = highlight ?
            (HighlightedText_1.HighlightedText({ text: displayLabel, searchText: highlight.highlightedText, activeMatchIndex })) :
            displayLabel;
        return (React.createElement(PropertyView_1.PropertyView, Object.assign({}, props, { labelElement: React.createElement(PrimitivePropertyLabelRenderer_1.PrimitivePropertyLabelRenderer, { offset: offset, renderColon: this.props.orientation === ui_core_1.Orientation.Horizontal, tooltip: displayLabel }, label) })));
    }
}
exports.PrimitivePropertyRenderer = PrimitivePropertyRenderer;
//# sourceMappingURL=PrimitivePropertyRenderer.js.map