/** @packageDocumentation
 * @module Properties
 */
/// <reference types="react" />
import { Orientation } from "@bentley/ui-core";
/** @internal */
export interface PropertyGridColumnInfo {
    minLabelWidth: number;
    minValueWidth: number;
    actionButtonWidth: number;
    isMinimumColumnSizeEnabled: boolean;
}
/** @internal */
export declare class PropertyGridColumnStyleProvider {
    private _minLabelWidth;
    private _minValueWidth;
    private _actionButtonWidth;
    private _isMinimumColumnSizeEnabled;
    constructor(columnInfo: PropertyGridColumnInfo | undefined);
    get minLabelWidth(): number;
    get minValueWidth(): number;
    get actionButtonWidth(): number;
    get isMinimumColumnSizeEnabled(): boolean;
    getStyle(orientation: Orientation, needActionButtons: boolean, ratio: number, needElementSeparator: boolean): React.CSSProperties;
    /** Join columns together in sequence, filtering out undefined column definitions */
    private columnStyleBuilder;
    private getHorizontalStyle;
    private getVerticalStyle;
}
//# sourceMappingURL=PropertyGridColumns.d.ts.map