/** @packageDocumentation
 * @module Properties
 */
import "./PropertyView.scss";
import * as React from "react";
import { SharedRendererProps } from "./PropertyRenderer";
/** Properties of [[PropertyView]] React component
 * @public
 */
export interface PropertyViewProps extends SharedRendererProps {
    /** Property label as a React element */
    labelElement: React.ReactNode;
    /** Property value as a React element */
    valueElement?: React.ReactNode;
    /** Render callback for property value. If specified, `valueElement` is ignored. */
    valueElementRenderer?: () => React.ReactNode;
}
/** @internal */
interface PropertyViewState {
    isHovered: boolean;
}
/**
 * A React component that renders property as label/value pair
 * @public
 */
export declare class PropertyView extends React.Component<PropertyViewProps, PropertyViewState> {
    constructor(props: PropertyViewProps);
    private _onClick;
    private _onMouseEnter;
    private _onMouseLeave;
    private _onContextMenu;
    private getClassName;
    /** @internal */
    render(): JSX.Element;
}
export {};
//# sourceMappingURL=PropertyView.d.ts.map