/** @packageDocumentation
 * @module Properties
 */
import "./PropertyLabelRenderer.scss";
import * as React from "react";
import { PrimitivePropertyLabelRendererProps } from "./PrimitivePropertyLabelRenderer";
/** Properties for the [[NonPrimitivePropertyLabelRenderer]] React component
 * @public
 */
export interface NonPrimitivePropertyLabelRendererProps extends PrimitivePropertyLabelRendererProps {
    isExpanded: boolean;
    onExpand: () => void;
    onCollapse: () => void;
}
/**
 * A React component that renders a non-primitive property label.
 * It renders an animated arrow with text which expands when label is clicked.
 * @public
 */
export declare class NonPrimitivePropertyLabelRenderer extends React.PureComponent<NonPrimitivePropertyLabelRendererProps> {
    private _onClick;
    render(): JSX.Element;
}
//# sourceMappingURL=NonPrimitivePropertyLabelRenderer.d.ts.map