"use strict";
/*---------------------------------------------------------------------------------------------
* Copyright (c) Bentley Systems, Incorporated. All rights reserved.
* See LICENSE.md in the project root for license terms and full copyright notice.
*--------------------------------------------------------------------------------------------*/
/** @packageDocumentation
 * @module Properties
 */
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.NonPrimitivePropertyLabelRenderer = void 0;
require("./PropertyLabelRenderer.scss");
const React = __importStar(require("react"));
const PropertyLabelRenderer_1 = require("./PropertyLabelRenderer");
/**
 * A React component that renders a non-primitive property label.
 * It renders an animated arrow with text which expands when label is clicked.
 * @public
 */
class NonPrimitivePropertyLabelRenderer extends React.PureComponent {
    constructor() {
        super(...arguments);
        this._onClick = () => {
            if (this.props.isExpanded)
                this.props.onCollapse();
            else
                this.props.onExpand();
        };
    }
    render() {
        return (React.createElement("div", { style: PropertyLabelRenderer_1.PropertyLabelRenderer.getStyle(this.props.offset), className: `components-nonprimitive-property-label-renderer ${this.props.className ? this.props.className : ""}`, onClick: this._onClick, role: "presentation" },
            React.createElement("div", { className: (this.props.isExpanded ? " components-expanded" : "") },
                React.createElement("i", { className: "icon icon-chevron-right" })),
            React.createElement(PropertyLabelRenderer_1.PropertyLabelRenderer, { renderColon: this.props.renderColon }, this.props.children)));
    }
}
exports.NonPrimitivePropertyLabelRenderer = NonPrimitivePropertyLabelRenderer;
//# sourceMappingURL=NonPrimitivePropertyLabelRenderer.js.map