/** @packageDocumentation
 * @module Properties
 */
import "./PropertyLabelRenderer.scss";
import * as React from "react";
import { PropertyLabelRendererProps } from "./PropertyLabelRenderer";
/** Properties of a [[PrimitivePropertyLabelRenderer]] React component
 * @public
 */
export interface PrimitivePropertyLabelRendererProps extends PropertyLabelRendererProps {
    /** Additional class name for the label wrapper */
    className?: string;
    /** Offset from the left side in pixels. */
    offset?: number;
}
/** A React component that renders a primitive property label
 * @public
 */
export declare class PrimitivePropertyLabelRenderer extends React.PureComponent<PrimitivePropertyLabelRendererProps> {
    render(): JSX.Element;
}
//# sourceMappingURL=PrimitivePropertyLabelRenderer.d.ts.map