/** @packageDocumentation
 * @module Properties
 */
import "./PropertyLabelRenderer.scss";
import * as React from "react";
/** Base properties for a property label renderer
 * @public
 */
export interface PropertyLabelRendererProps {
    /** Label to be rendered */
    children: string | JSX.Element;
    /** Indicates whether to render a colon after the label */
    renderColon?: boolean;
    /** Custom tooltip for the component.
     * @beta
     */
    tooltip?: string;
}
/** @internal */
export declare class PropertyLabelRenderer extends React.PureComponent<PropertyLabelRendererProps> {
    /** Get React CSS style object based on provided offset from the left side */
    static getStyle(offset?: number): React.CSSProperties;
    render(): JSX.Element;
}
//# sourceMappingURL=PropertyLabelRenderer.d.ts.map