"use strict";
/*---------------------------------------------------------------------------------------------
* Copyright (c) Bentley Systems, Incorporated. All rights reserved.
* See LICENSE.md in the project root for license terms and full copyright notice.
*--------------------------------------------------------------------------------------------*/
/** @packageDocumentation
 * @module Properties
 */
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.PropertyLabelRenderer = void 0;
require("./PropertyLabelRenderer.scss");
const React = __importStar(require("react"));
/** @internal */
class PropertyLabelRenderer extends React.PureComponent {
    /** Get React CSS style object based on provided offset from the left side */
    static getStyle(offset) {
        offset = offset ? offset : 0;
        return {
            paddingLeft: offset,
            width: `calc(100% - ${offset}px)`,
        };
    }
    render() {
        var _a;
        const title = (_a = this.props.tooltip) !== null && _a !== void 0 ? _a : (typeof this.props.children == "string" ? this.props.children : /* istanbul ignore next */ undefined);
        return (React.createElement(React.Fragment, null,
            React.createElement("span", { className: "components-property-label-renderer", title: title }, this.props.children),
            this.props.renderColon ? React.createElement("span", { className: "components-property-label-renderer-colon" }, ":") : undefined));
    }
}
exports.PropertyLabelRenderer = PropertyLabelRenderer;
//# sourceMappingURL=PropertyLabelRenderer.js.map