"use strict";
/*---------------------------------------------------------------------------------------------
* Copyright (c) Bentley Systems, Incorporated. All rights reserved.
* See LICENSE.md in the project root for license terms and full copyright notice.
*--------------------------------------------------------------------------------------------*/
/** @packageDocumentation
 * @module Properties
 */
Object.defineProperty(exports, "__esModule", { value: true });
exports.MergedPropertyValueRenderer = void 0;
const ui_abstract_1 = require("@bentley/ui-abstract");
const UiComponents_1 = require("../../../UiComponents");
const WithContextStyle_1 = require("./WithContextStyle");
/** Default Merged Property Renderer
 * @public
 */
class MergedPropertyValueRenderer {
    /** Checks if the renderer can handle given property */
    canRender(record) {
        return !!record.isMerged && record.value.valueFormat === ui_abstract_1.PropertyValueFormat.Primitive;
    }
    /** Method that returns a JSX representation of PropertyRecord */
    render(_record, context) {
        return WithContextStyle_1.withContextStyle(UiComponents_1.UiComponents.translate("property.varies"), context);
    }
}
exports.MergedPropertyValueRenderer = MergedPropertyValueRenderer;
//# sourceMappingURL=MergedPropertyValueRenderer.js.map