/**
 * @packageDocumentation
 * @module Properties
 */
import * as React from "react";
import { PropertyRecord } from "@bentley/ui-abstract";
import { IPropertyValueRenderer, PropertyValueRendererContext } from "../../ValueRendererManager";
/** @internal */
export declare class MultilineTextPropertyValueRenderer implements IPropertyValueRenderer {
    canRender(record: PropertyRecord): boolean;
    render(record: PropertyRecord, context?: PropertyValueRendererContext): React.ReactNode;
}
interface MultilineTextRenderer {
    stringValue?: string;
    isExpanded?: boolean;
    onExpansionToggled?: () => void;
    onHeightChanged?: (newHeight: number) => void;
    style?: React.CSSProperties;
}
/** @internal */
export declare const MultilineTextRenderer: React.FC<MultilineTextRenderer>;
export {};
//# sourceMappingURL=MultilineTextPropertyValueRenderer.d.ts.map