"use strict";
/*---------------------------------------------------------------------------------------------
* Copyright (c) Bentley Systems, Incorporated. All rights reserved.
* See LICENSE.md in the project root for license terms and full copyright notice.
*--------------------------------------------------------------------------------------------*/
/** @packageDocumentation
 * @module Properties
 */
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.StructPropertyValueRenderer = void 0;
const React = __importStar(require("react"));
const ui_abstract_1 = require("@bentley/ui-abstract");
const ui_core_1 = require("@bentley/ui-core");
const ValueRendererManager_1 = require("../../ValueRendererManager");
const StructValueRenderer_1 = require("./table/StructValueRenderer");
const WithContextStyle_1 = require("./WithContextStyle");
/** Default Struct Property Renderer
 * @public
 */
class StructPropertyValueRenderer {
    /** Checks if the renderer can handle given property */
    canRender(record) {
        return record.value.valueFormat === ui_abstract_1.PropertyValueFormat.Struct;
    }
    /** Method that returns a JSX representation of PropertyRecord */
    render(record, context) {
        if (context && context.containerType === ValueRendererManager_1.PropertyContainerType.Table) {
            return WithContextStyle_1.withContextStyle(React.createElement(StructValueRenderer_1.TableStructValueRenderer, { propertyRecord: record, onDialogOpen: context.onDialogOpen, orientation: context.orientation ? context.orientation : ui_core_1.Orientation.Horizontal }), context);
        }
        if (context && context.containerType === ValueRendererManager_1.PropertyContainerType.PropertyPane) {
            return WithContextStyle_1.withContextStyle("", context);
        }
        return WithContextStyle_1.withContextStyle(`{${record.property.typename}}`, context);
    }
}
exports.StructPropertyValueRenderer = StructPropertyValueRenderer;
//# sourceMappingURL=StructPropertyValueRenderer.js.map