/** @packageDocumentation
 * @module Properties
 */
import { PropertyRecord } from "@bentley/ui-abstract";
import { IPropertyValueRenderer, PropertyValueRendererContext } from "../../ValueRendererManager";
/**
 * URL property value renderer that renders the whole value as a URL without matching it
 * against URL regex.
 *
 * @public
 */
export declare class UrlPropertyValueRenderer implements IPropertyValueRenderer {
    /** Checks if the renderer can handle given property */
    canRender(record: PropertyRecord): boolean;
    /** Method that returns a JSX representation of PropertyRecord */
    render(record: PropertyRecord, context?: PropertyValueRendererContext): JSX.Element;
}
//# sourceMappingURL=UrlPropertyValueRenderer.d.ts.map