"use strict";
/*---------------------------------------------------------------------------------------------
* Copyright (c) Bentley Systems, Incorporated. All rights reserved.
* See LICENSE.md in the project root for license terms and full copyright notice.
*--------------------------------------------------------------------------------------------*/
/** @packageDocumentation
 * @module Properties
 */
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.TableArrayValueRenderer = void 0;
const React = __importStar(require("react"));
const NonPrimitivePropertyRenderer_1 = require("../../NonPrimitivePropertyRenderer");
const NonPrimitiveValueRenderer_1 = require("./NonPrimitiveValueRenderer");
/** A react component which renders array property value as a button with text
 * @public
 */
class TableArrayValueRenderer extends React.PureComponent {
    getButtonLabel(props) {
        const value = props.propertyRecord.value;
        return value.items.length !== 0 ? `${value.itemsTypeName}[${value.items.length}]` : "[]";
    }
    getDialogContents() {
        return (React.createElement(NonPrimitivePropertyRenderer_1.NonPrimitivePropertyRenderer, { uniqueKey: `table_array_${this.props.propertyRecord.property.name}`, orientation: this.props.orientation, propertyRecord: this.props.propertyRecord }));
    }
    /** @internal */
    render() {
        const typeName = this.props.propertyRecord.value.itemsTypeName;
        return (React.createElement(NonPrimitiveValueRenderer_1.TableNonPrimitiveValueRenderer, { buttonLabel: this.getButtonLabel(this.props), dialogContents: this.getDialogContents(), dialogTitle: `Array of type "${typeName}"`, onDialogOpen: this.props.onDialogOpen }));
    }
}
exports.TableArrayValueRenderer = TableArrayValueRenderer;
//# sourceMappingURL=ArrayValueRenderer.js.map