"use strict";
/*---------------------------------------------------------------------------------------------
* Copyright (c) Bentley Systems, Incorporated. All rights reserved.
* See LICENSE.md in the project root for license terms and full copyright notice.
*--------------------------------------------------------------------------------------------*/
/** @packageDocumentation
 * @module Properties
 */
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.TableNonPrimitiveValueRenderer = void 0;
require("./NonPrimitiveValueRenderer.scss");
const React = __importStar(require("react"));
const ui_core_1 = require("@bentley/ui-core");
/**
 * A React component that renders non primitive values as a button with text.
 * When clicked, a dialog appears that shows the value in greater detail.
 * @public
 */
class TableNonPrimitiveValueRenderer extends React.PureComponent {
    constructor() {
        // private _buttonRef = React.createRef<HTMLButtonElement>();
        super(...arguments);
        this._onClick = () => {
            if (!this.props.onDialogOpen)
                return;
            const dialogState = { content: this.props.dialogContents, title: this.props.dialogTitle };
            this.props.onDialogOpen(dialogState);
        };
    }
    // TODO: Enable, when table gets refactored
    // Disabled fancy tooltips, because table controls it's state.
    // But, because everything is in table state and there is no shouldComponentUpdate,
    // tooltips cause rerender of the whole table
    // private _showTooltip = () => {
    //   if (!this.props.onPopupShow)
    //     return;
    //   const buttonElement = this._buttonRef.current;
    //   if (!buttonElement)
    //     return;
    //   const buttonBox = buttonElement.getBoundingClientRect();
    //   const popupState: PropertyPopupState = {
    //     fixedPosition: {
    //       top: buttonBox.top - 10,
    //       left: buttonBox.left + buttonBox.width / 2,
    //     },
    //     content:
    //       <span className="components-table-value-popup">
    //         {`View ${this.props.buttonLabel} in more detail.`}
    //       </span>,
    //   };
    //   this.props.onPopupShow(popupState);
    // }
    // private _hideTooltip = () => {
    //   if (this.props.onPopupHide)
    //     this.props.onPopupHide();
    // }
    /** @internal */
    render() {
        return (React.createElement(ui_core_1.UnderlinedButton
        // ref={this._buttonRef}
        , { 
            // ref={this._buttonRef}
            className: "components-table-value-button", onClick: this._onClick, 
            // onMouseEnter={this._showTooltip}
            // onMouseLeave={this._hideTooltip}
            title: `View ${this.props.buttonLabel} in more detail.` }, this.props.buttonLabel));
    }
}
exports.TableNonPrimitiveValueRenderer = TableNonPrimitiveValueRenderer;
//# sourceMappingURL=NonPrimitiveValueRenderer.js.map