/** @packageDocumentation
 * @module PropertyGrid
 */
import { PropertyRecord } from "@bentley/ui-abstract";
import { IPropertyDataProvider, PropertyCategory, PropertyData, PropertyDataChangeEvent } from "./PropertyDataProvider";
/**
 * Implementation of [IPropertyDataProvider] that uses an associative array.
 * @public
 */
export declare class SimplePropertyDataProvider implements IPropertyDataProvider, PropertyData {
    label: PropertyRecord;
    description?: string;
    categories: PropertyCategory[];
    records: {
        [categoryName: string]: PropertyRecord[];
    };
    onDataChanged: PropertyDataChangeEvent;
    addCategory(category: PropertyCategory): number;
    findCategoryIndex(category: PropertyCategory): number;
    addProperty(propertyRecord: PropertyRecord, categoryIdx: number): void;
    removeProperty(propertyRecord: PropertyRecord, categoryIdx: number): boolean;
    replaceProperty(propertyRecord: PropertyRecord, categoryIdx: number, newRecord: PropertyRecord): boolean;
    getData(): Promise<PropertyData>;
}
//# sourceMappingURL=SimplePropertyDataProvider.d.ts.map