import * as React from "react";
import { Orientation } from "@bentley/ui-core";
import { PropertyListProps } from "./PropertyList";
/** @internal */
export declare type ColumnResizeRelatedPropertyListProps = Required<Pick<PropertyListProps, "onColumnChanged" | "columnRatio" | "isResizeHandleHovered" | "onResizeHandleHoverChanged" | "isResizeHandleBeingDragged" | "onResizeHandleDragChanged" | "columnInfo" | "onListWidthChanged" | "orientation">>;
/** @internal */
export interface ColumnResizingPropertyListPropsSupplierProps {
    /** Orientation of the properties */
    orientation: Orientation;
    /** Minimum allowed label column width, after which resizing stops */
    minLabelWidth?: number;
    /** Minimum allowed value column width, after which resizing stops */
    minValueWidth?: number;
    /** Fixed action button column width */
    actionButtonWidth?: number;
    /** A callback that receives the required column-resize-related props for the [[PropertyList]] component  */
    children: (props: ColumnResizeRelatedPropertyListProps) => React.ReactNode;
}
/** @internal */
export interface ColumnResizingPropertyListPropsSupplierState {
    columnRatio: number;
    isResizeHandleHovered: boolean;
    isResizeHandleBeingDragged: boolean;
    isMinimumColumnSizeEnabled: boolean;
}
/**
 * Wrapped PropertyCategoryBlock React component with list of properties and render optimization
 * @internal
 */
export declare class ColumnResizingPropertyListPropsSupplier extends React.Component<ColumnResizingPropertyListPropsSupplierProps, ColumnResizingPropertyListPropsSupplierState> {
    private readonly _initialRatio;
    private readonly _defaultMinRatio;
    private readonly _defaultMaxRatio;
    private _minRatio;
    private _maxRatio;
    state: ColumnResizingPropertyListPropsSupplierState;
    static defaultProps: Partial<ColumnResizingPropertyListPropsSupplierProps>;
    private _onColumnRatioChanged;
    private _onResizeHandleHoverChanged;
    private _onResizeHandleDragChanged;
    private _onListWidthChange;
    private getValidColumnRatio;
    render(): React.ReactNode;
}
//# sourceMappingURL=ColumnResizingPropertyListPropsSupplier.d.ts.map