"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.FlatItemNestedBorderWrapper = void 0;
/*---------------------------------------------------------------------------------------------
* Copyright (c) Bentley Systems, Incorporated. All rights reserved.
* See LICENSE.md in the project root for license terms and full copyright notice.
*--------------------------------------------------------------------------------------------*/
const classnames_1 = __importDefault(require("classnames"));
const React = __importStar(require("react"));
/**
 * FlatItemNestedBorderWrapper React component.
 * Wraps provided ReactNode in nested borders recursively according to provided borderCount.
 * @internal
 */
function FlatItemNestedBorderWrapper(props) {
    if (props.borderCount <= 0) {
        return (React.createElement("div", { className: props.className }, props.children));
    }
    const isBottomBorderNeeded = props.bottomBorderCount >= 0 && props.bottomBorderCount >= props.borderCount;
    const classNames = classnames_1.default("nested-border-middle", isBottomBorderNeeded ? "nested-border-bottom" : undefined);
    let currentBottomBorderCount = props.bottomBorderCount;
    if (isBottomBorderNeeded)
        currentBottomBorderCount--;
    return (React.createElement("div", { className: classNames },
        React.createElement(FlatItemNestedBorderWrapper, { className: props.className, borderCount: props.borderCount - 1, bottomBorderCount: currentBottomBorderCount }, props.children)));
}
exports.FlatItemNestedBorderWrapper = FlatItemNestedBorderWrapper;
//# sourceMappingURL=FlatItemNestedBorderWrapper.js.map