/** @packageDocumentation
 * @module PropertyGrid
 */
import * as React from "react";
import { CommonProps } from "@bentley/ui-core";
import { HighlightingComponentProps } from "../../common/HighlightingComponentProps";
import { PropertyCategory } from "../PropertyDataProvider";
/**
 * Properties for the [[PropertyCategoryBlock]] React component
 * @public
 */
export interface PropertyCategoryBlockProps extends CommonProps {
    /** Category of the properties */
    category: PropertyCategory;
    /** Callback to when PropertyCategoryBlock gets expended or collapsed */
    onExpansionToggled?: (categoryName: string) => void;
    /** Properties used for highlighting
    * @beta
    */
    highlight?: HighlightingComponentProps;
}
/**
 * PropertyCategoryBlock React component
 * @public
 */
export declare class PropertyCategoryBlock extends React.Component<PropertyCategoryBlockProps> {
    constructor(props: PropertyCategoryBlockProps);
    private toggleExpansion;
    private _onClick;
    private _onKeyPress;
    /** @internal */
    render(): JSX.Element;
}
//# sourceMappingURL=PropertyCategoryBlock.d.ts.map