/** @packageDocumentation
 * @module PropertyGrid
 */
import "./PropertyGrid.scss";
import * as React from "react";
import { CommonPropertyGridProps } from "./PropertyGridCommons";
import { PropertyListProps } from "./PropertyList";
/** @internal */
export declare type PropertyGridEventsRelatedProps = Pick<PropertyListProps, "onPropertyClicked" | "onPropertyRightClicked" | "onPropertyContextMenu" | "onEditCommit" | "onEditCancel" | "selectedPropertyKey" | "editingPropertyKey"> & Pick<CommonPropertyGridProps, "isPropertySelectionOnRightClickEnabled" | "isPropertyEditingEnabled"> & Required<Pick<CommonPropertyGridProps, "isPropertyHoverEnabled" | "isPropertySelectionEnabled">>;
/** Properties for [[PropertyGridEventsRelatedPropsSupplier]] React component
 * @internal
 */
export declare type PropertyGridEventsRelatedPropsSupplierProps = Pick<CommonPropertyGridProps, "onPropertyContextMenu" | "isPropertySelectionOnRightClickEnabled" | "isPropertySelectionOnRightClickEnabled" | "onPropertySelectionChanged" | "isPropertyEditingEnabled" | "onPropertyUpdated"> & Required<Pick<CommonPropertyGridProps, "isPropertyHoverEnabled" | "isPropertySelectionEnabled">> & {
    children: (context: PropertyGridEventsRelatedProps) => React.ReactNode;
};
/** State of [[PropertyGridEventsRelatedPropsSupplier]] React component
 * @internal
 */
interface PropertyGridEventsRelatedPropsSupplierState {
    /** Unique key of currently selected property */
    selectedPropertyKey?: string;
    /** Unique key of currently edited property */
    editingPropertyKey?: string;
}
/** PropertyGridEventsRelatedPropsSupplier React component.
 * @internal
 */
export declare class PropertyGridEventsRelatedPropsSupplier extends React.Component<PropertyGridEventsRelatedPropsSupplierProps, PropertyGridEventsRelatedPropsSupplierState> {
    /** @internal */
    constructor(props: PropertyGridEventsRelatedPropsSupplierProps);
    private _isClickSupported;
    private _isRightClickSupported;
    private _onPropertyRightClicked;
    private _onPropertyClicked;
    private _onPropertyContextMenu;
    private _onEditCommit;
    private _onEditCancel;
    private onEnabledPropertyRightClicked;
    private onEnabledPropertyLeftClicked;
    /** @internal */
    render(): JSX.Element;
}
export {};
//# sourceMappingURL=PropertyGridEventsRelatedPropsSupplier.d.ts.map