/** @packageDocumentation
 * @module PropertyGrid
 */
import { PropertyRecord } from "@bentley/ui-abstract";
import { PropertyCategory } from "../../PropertyDataProvider";
import { IPropertyDataFilterer, PropertyDataFiltererBase, PropertyDataFilterResult } from "./PropertyDataFiltererBase";
/**
 * Logical operator for composite filterer.
 * @beta
 */
export declare enum CompositeFilterType {
    And = 0,
    Or = 1
}
/**
 * Composite PropertyData filter which can join two filters using logic operators
 * @beta
 */
export declare class CompositePropertyDataFilterer extends PropertyDataFiltererBase {
    private _leftFilterer;
    private _operator;
    private _rightFilterer;
    constructor(_leftFilterer: IPropertyDataFilterer, _operator: CompositeFilterType, _rightFilterer: IPropertyDataFilterer);
    get isActive(): boolean;
    recordMatchesFilter(node: PropertyRecord, parents: PropertyRecord[]): Promise<PropertyDataFilterResult>;
    categoryMatchesFilter(node: PropertyCategory, parents: PropertyCategory[]): Promise<PropertyDataFilterResult>;
    private getFiltererResult;
}
//# sourceMappingURL=CompositePropertyDataFilterer.d.ts.map