/** @packageDocumentation
 * @module PropertyGrid
 */
import { IPropertyGridModelSource } from "./PropertyGridModelSource";
/**
 * Handles events and changes on PropertyGridModel data.
 * @beta
 */
export interface IPropertyGridEventHandler {
    onExpansionToggled: (selectionKey: string) => void;
}
/**
 * Handles events and changes on PropertyGridModel data.
 * @beta
 */
export declare class PropertyGridEventHandler {
    private _modelSource;
    constructor(_modelSource: IPropertyGridModelSource);
    /**
     * Flips isExpand on item by given selectionKey
     * @param selectionKey item to be modified
     */
    onExpansionToggled: (selectionKey: string) => void;
}
//# sourceMappingURL=PropertyGridEventHandler.d.ts.map