"use strict";
/*---------------------------------------------------------------------------------------------
* Copyright (c) Bentley Systems, Incorporated. All rights reserved.
* See LICENSE.md in the project root for license terms and full copyright notice.
*--------------------------------------------------------------------------------------------*/
Object.defineProperty(exports, "__esModule", { value: true });
exports.PropertyGridEventHandler = void 0;
/**
 * Handles events and changes on PropertyGridModel data.
 * @beta
 */
class PropertyGridEventHandler {
    constructor(_modelSource) {
        this._modelSource = _modelSource;
        /**
         * Flips isExpand on item by given selectionKey
         * @param selectionKey item to be modified
         */
        this.onExpansionToggled = (selectionKey) => {
            this._modelSource.modifyModel((draftModel) => {
                const item = draftModel.getItem(selectionKey);
                item.isExpanded = !item.isExpanded;
            });
        };
    }
}
exports.PropertyGridEventHandler = PropertyGridEventHandler;
//# sourceMappingURL=PropertyGridEventHandler.js.map