/** @packageDocumentation
 * @module PropertyGrid
 */
import { PropertyRecord } from "@bentley/ui-abstract";
import { FlatGridItemType, IMutableCategorizedPropertyItem, IMutableFlatGridItem, MutableCategorizedProperty } from "./MutableFlatGridItem";
import { IMutableGridItemFactory } from "./MutableGridItemFactory";
/**
 * Mutable wrapper object for PropertyRecord with array valueFormat which provides methods for working with and managing record children hierarchies.
 * @beta
 */
export declare class MutableCategorizedArrayProperty extends MutableCategorizedProperty implements IMutableCategorizedPropertyItem {
    private _renderLabel;
    private _children;
    constructor(record: PropertyRecord, parentSelectionKey: string, parentCategorySelectionKey: string, depth: number, gridItemFactory: IMutableGridItemFactory, overrideName?: string, overrideDisplayLabel?: string);
    get type(): FlatGridItemType.Array;
    getChildren(): IMutableCategorizedPropertyItem[];
    getDescendantsAndSelf(): IMutableFlatGridItem[];
    getVisibleDescendants(): IMutableFlatGridItem[];
    getVisibleDescendantsAndSelf(): IMutableFlatGridItem[];
}
//# sourceMappingURL=MutableCategorizedArrayProperty.d.ts.map