"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.FlatNonPrimitivePropertyRenderer = void 0;
/*---------------------------------------------------------------------------------------------
* Copyright (c) Bentley Systems, Incorporated. All rights reserved.
* See LICENSE.md in the project root for license terms and full copyright notice.
*--------------------------------------------------------------------------------------------*/
/** @packageDocumentation
 * @module PropertyGrid
 */
require("../../../properties/renderers/NonPrimitivePropertyRenderer.scss");
const React = __importStar(require("react"));
const ui_abstract_1 = require("@bentley/ui-abstract");
const CommonPropertyRenderer_1 = require("../../../properties/renderers/CommonPropertyRenderer");
const NonPrimitivePropertyLabelRenderer_1 = require("../../../properties/renderers/label/NonPrimitivePropertyLabelRenderer");
const PropertyView_1 = require("../../../properties/renderers/PropertyView");
/** React Component that renders flat struct and array properties
 * @internal
 */
class FlatNonPrimitivePropertyRenderer extends React.Component {
    constructor(props) {
        super(props);
        this._onExpanded = () => {
            /* istanbul ignore else */
            if (!this.props.isExpanded)
                this.props.onExpandToggled();
        };
        this._onCollapsed = () => {
            /* istanbul ignore else */
            if (this.props.isExpanded)
                this.props.onExpandToggled();
        };
    }
    getLabel(props) {
        const { orientation, indentation, width, columnRatio, columnInfo } = props;
        const offset = CommonPropertyRenderer_1.CommonPropertyRenderer.getLabelOffset(indentation, orientation, width, columnRatio, columnInfo === null || columnInfo === void 0 ? void 0 : columnInfo.minLabelWidth);
        let displayLabel = props.propertyRecord.property.displayLabel;
        if (props.propertyRecord.value.valueFormat === ui_abstract_1.PropertyValueFormat.Array)
            displayLabel = `${displayLabel} (${props.propertyRecord.value.items.length})`;
        return (React.createElement(NonPrimitivePropertyLabelRenderer_1.NonPrimitivePropertyLabelRenderer, { isExpanded: props.isExpanded, onExpand: this._onExpanded, onCollapse: this._onCollapsed, offset: offset, renderColon: false }, displayLabel));
    }
    /** @internal */
    render() {
        // eslint-disable-next-line @typescript-eslint/no-unused-vars
        const _a = this.props, { children, indentation } = _a, props = __rest(_a, ["children", "indentation"]);
        return (React.createElement(PropertyView_1.PropertyView, Object.assign({ labelElement: this.getLabel(this.props) }, props)));
    }
}
exports.FlatNonPrimitivePropertyRenderer = FlatNonPrimitivePropertyRenderer;
//# sourceMappingURL=FlatNonPrimitivePropertyRenderer.js.map