/** @packageDocumentation
 * @module QuantityFormat
 */
import "./FormatPanel.scss";
import * as React from "react";
import { FormatProps, FormatterSpec, UnitProps, UnitsProvider } from "@bentley/imodeljs-quantity";
import { CommonProps } from "@bentley/ui-core";
/** Properties of [[FormatPanel]] component.
 * @alpha
 */
export interface FormatPanelProps extends CommonProps {
    initialFormat: FormatProps;
    unitsProvider: UnitsProvider;
    persistenceUnit: Promise<UnitProps> | UnitProps;
    showSample?: boolean;
    initialMagnitude?: number;
    enableMinimumProperties?: boolean;
    onFormatChange?: (format: FormatProps) => void;
    provideFormatSpec?: (formatProps: FormatProps, persistenceUnit: UnitProps, unitsProvider: UnitsProvider) => Promise<FormatterSpec>;
    providePrimaryChildren?: (formatProps: FormatProps, fireFormatChange: (newProps: FormatProps) => void) => React.ReactNode;
    provideSecondaryChildren?: (formatProps: FormatProps, fireFormatChange: (newProps: FormatProps) => void) => React.ReactNode;
}
/** Component to show/edit Quantity Format.
 * @alpha
 */
export declare function FormatPanel(props: FormatPanelProps): JSX.Element;
//# sourceMappingURL=FormatPanel.d.ts.map