"use strict";
/*---------------------------------------------------------------------------------------------
* Copyright (c) Bentley Systems, Incorporated. All rights reserved.
* See LICENSE.md in the project root for license terms and full copyright notice.
*--------------------------------------------------------------------------------------------*/
/** @packageDocumentation
 * @module QuantityFormat
 */
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.FormatPrecision = void 0;
const React = __importStar(require("react"));
const imodeljs_quantity_1 = require("@bentley/imodeljs-quantity");
const DecimalPrecision_1 = require("./misc/DecimalPrecision");
const FractionPrecision_1 = require("./misc/FractionPrecision");
const UiComponents_1 = require("../UiComponents");
/** Component to show/edit Quantity Format Precision.
 * @alpha
 */
function FormatPrecision(props) {
    var _a, _b;
    const { formatProps, onChange } = props;
    const handlePrecisionChange = React.useCallback((precision) => {
        const newFormatProps = Object.assign(Object.assign({}, formatProps), { precision });
        onChange && onChange(newFormatProps);
    }, [formatProps, onChange]);
    const formatType = imodeljs_quantity_1.Format.parseFormatType(formatProps.type, "format");
    const label = React.useRef(UiComponents_1.UiComponents.translate("QuantityFormat.labels.precision"));
    return (React.createElement(React.Fragment, null,
        React.createElement("span", { className: "uicore-label" }, label.current),
        formatType === imodeljs_quantity_1.FormatType.Fractional ?
            React.createElement(FractionPrecision_1.FractionPrecisionSelector, { "data-testid": "fraction-precision-selector", precision: (_a = formatProps.precision) !== null && _a !== void 0 ? _a : 0, onChange: handlePrecisionChange }) :
            React.createElement(DecimalPrecision_1.DecimalPrecisionSelector, { "data-testid": "decimal-precision-selector", precision: (_b = formatProps.precision) !== null && _b !== void 0 ? _b : 0, onChange: handlePrecisionChange })));
}
exports.FormatPrecision = FormatPrecision;
//# sourceMappingURL=FormatPrecision.js.map