/** @packageDocumentation
 * @module QuantityFormat
 */
import { CommonProps } from "@bentley/ui-core";
import { FormatProps, UnitProps, UnitsProvider } from "@bentley/imodeljs-quantity";
/** Properties of [[FormatUnits]] component.
 * @alpha
 */
export interface FormatUnitsProps extends CommonProps {
    initialFormat: FormatProps;
    persistenceUnit?: UnitProps;
    unitsProvider: UnitsProvider;
    onUnitsChange?: (format: FormatProps) => void;
}
/** Component to show/edit Units used for Quantity Formatting.
 * @alpha
 */
export declare function FormatUnits(props: FormatUnitsProps): JSX.Element;
//# sourceMappingURL=FormatUnits.d.ts.map