/** @packageDocumentation
 * @module QuantityFormat
 */
import * as React from "react";
import { CommonProps } from "@bentley/ui-core";
import { FormatProps } from "@bentley/imodeljs-quantity";
/** Properties of [[MiscFormatOptions]] component.
 * @alpha
 */
export interface MiscFormatOptionsProps extends CommonProps {
    formatProps: FormatProps;
    onChange?: (format: FormatProps) => void;
    enableMinimumProperties?: boolean;
    showOptions: boolean;
    onShowHideOptions: (show: boolean) => void;
    children?: React.ReactNode;
}
/** Component use to set miscellaneous properties is a Formatted Quantity.
 * @alpha
 */
export declare function MiscFormatOptions(props: MiscFormatOptionsProps): JSX.Element;
//# sourceMappingURL=MiscFormatOptions.d.ts.map