/** @packageDocumentation
 * @module QuantityFormat
 */
import { QuantityTypeArg } from "@bentley/imodeljs-frontend";
import { FormatProps } from "@bentley/imodeljs-quantity";
import { CommonProps } from "@bentley/ui-core";
/** Properties of [[QuantityFormatPanel]] component.
 * @alpha
 */
export interface QuantityFormatPanelProps extends CommonProps {
    quantityType: QuantityTypeArg;
    onFormatChange?: (format: FormatProps) => void;
    /** props below are to be passed on to FormatPanel */
    showSample?: boolean;
    initialMagnitude?: number;
    enableMinimumProperties?: boolean;
}
/** Component to set properties that control Quantity Formatting.
 * @alpha
 */
export declare function QuantityFormatPanel(props: QuantityFormatPanelProps): JSX.Element;
//# sourceMappingURL=QuantityFormatPanel.d.ts.map