"use strict";
/*---------------------------------------------------------------------------------------------
* Copyright (c) Bentley Systems, Incorporated. All rights reserved.
* See LICENSE.md in the project root for license terms and full copyright notice.
*--------------------------------------------------------------------------------------------*/
/** @packageDocumentation
 * @module QuantityFormat
 */
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.DecimalPrecisionSelector = void 0;
const React = __importStar(require("react"));
const ui_core_1 = require("@bentley/ui-core");
const UiComponents_1 = require("../../UiComponents");
/** Component use to set Decimal Precision
 * the unit label.
 * @internal
 */
function DecimalPrecisionSelector(props) {
    const { precision, onChange } = props, otherProps = __rest(props, ["precision", "onChange"]);
    const options = React.useRef([
        { value: 0, label: UiComponents_1.UiComponents.translate("QuantityFormat.decimal_precision.zero") },
        { value: 1, label: UiComponents_1.UiComponents.translate("QuantityFormat.decimal_precision.one") },
        { value: 2, label: UiComponents_1.UiComponents.translate("QuantityFormat.decimal_precision.two") },
        { value: 3, label: UiComponents_1.UiComponents.translate("QuantityFormat.decimal_precision.three") },
        { value: 4, label: UiComponents_1.UiComponents.translate("QuantityFormat.decimal_precision.four") },
        { value: 5, label: UiComponents_1.UiComponents.translate("QuantityFormat.decimal_precision.five") },
        { value: 6, label: UiComponents_1.UiComponents.translate("QuantityFormat.decimal_precision.six") },
        { value: 7, label: UiComponents_1.UiComponents.translate("QuantityFormat.decimal_precision.seven") },
        { value: 8, label: UiComponents_1.UiComponents.translate("QuantityFormat.decimal_precision.eight") },
        { value: 9, label: UiComponents_1.UiComponents.translate("QuantityFormat.decimal_precision.nine") },
        { value: 10, label: UiComponents_1.UiComponents.translate("QuantityFormat.decimal_precision.ten") },
        { value: 11, label: UiComponents_1.UiComponents.translate("QuantityFormat.decimal_precision.eleven") },
        { value: 12, label: UiComponents_1.UiComponents.translate("QuantityFormat.decimal_precision.twelve") },
    ]);
    const handleOnChange = React.useCallback((e) => {
        e.preventDefault();
        const newValue = Number.parseInt(e.target.value, 10);
        onChange && onChange(newValue);
    }, [onChange]);
    return (React.createElement(ui_core_1.Select, Object.assign({ options: options.current, value: precision, onChange: handleOnChange }, otherProps)));
}
exports.DecimalPrecisionSelector = DecimalPrecisionSelector;
//# sourceMappingURL=DecimalPrecision.js.map