/** @packageDocumentation
 * @module QuantityFormat
 */
import { UnitsProvider } from "@bentley/imodeljs-quantity";
import { CommonProps } from "@bentley/ui-core";
/** Properties of [[UnitDescr]] component.
 * @internal
 */
export interface UnitDescrProps extends CommonProps {
    name: string;
    parentUnitName?: string;
    label: string;
    index: number;
    unitsProvider: UnitsProvider;
    readonly?: boolean;
    onUnitChange: (value: string, index: number) => void;
    onLabelChange: (value: string, index: number) => void;
}
/** Component use to display dropdown list of possible units.
 * @internal
 */
export declare function UnitDescr(props: UnitDescrProps): JSX.Element;
//# sourceMappingURL=UnitDescr.d.ts.map