"use strict";
/*---------------------------------------------------------------------------------------------
* Copyright (c) Bentley Systems, Incorporated. All rights reserved.
* See LICENSE.md in the project root for license terms and full copyright notice.
*--------------------------------------------------------------------------------------------*/
/** @packageDocumentation
 * @module Table
 */
Object.defineProperty(exports, "__esModule", { value: true });
exports.TableDataChangeEvent = exports.FilterRenderer = void 0;
const bentleyjs_core_1 = require("@bentley/bentleyjs-core");
// cSpell:ignore columnfiltering
/** Filter Renderer for a Table column
 * @public
 */
var FilterRenderer;
(function (FilterRenderer) {
    FilterRenderer[FilterRenderer["Numeric"] = 1] = "Numeric";
    FilterRenderer[FilterRenderer["MultiSelect"] = 2] = "MultiSelect";
    FilterRenderer[FilterRenderer["SingleSelect"] = 3] = "SingleSelect";
    FilterRenderer[FilterRenderer["Text"] = 4] = "Text";
    FilterRenderer[FilterRenderer["MultiValue"] = 5] = "MultiValue";
})(FilterRenderer = exports.FilterRenderer || (exports.FilterRenderer = {}));
/** An event broadcasted on table data changes
 * @public
 */
class TableDataChangeEvent extends bentleyjs_core_1.BeEvent {
}
exports.TableDataChangeEvent = TableDataChangeEvent;
//# sourceMappingURL=TableDataProvider.js.map