"use strict";
/*---------------------------------------------------------------------------------------------
* Copyright (c) Bentley Systems, Incorporated. All rights reserved.
* See LICENSE.md in the project root for license terms and full copyright notice.
*--------------------------------------------------------------------------------------------*/
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.AutoCompleteFilter = void 0;
/*---------------------------------------------------------------------------------------------
* This code has been adapted from
* [react-data-grid-addons](https://github.com/adazzle/react-data-grid/tree/master/packages/react-data-grid-addons).
*--------------------------------------------------------------------------------------------*/
const _ = __importStar(require("lodash"));
const react_1 = __importDefault(require("react"));
const ui_core_1 = require("@bentley/ui-core");
const UiComponents_1 = require("../../../UiComponents");
/* istanbul ignore next */
/** @internal */
class AutoCompleteFilter extends react_1.default.Component {
    constructor(props) {
        super(props);
        this._placeholder = UiComponents_1.UiComponents.translate("button.label.filter");
        this._getOptions = (newProps) => {
            const props = newProps || this.props;
            let options = props.getValidFilterValues(props.column.key);
            options = options.map((o) => {
                if (typeof o === "string") {
                    return { value: o, label: o };
                }
                return o;
            });
            return options;
        };
        this._handleChange = (value) => {
            const filters = value;
            this.setState({ filters });
            this.props.onChange({ filterTerm: filters, column: this.props.column });
        };
        this.state = {
            options: this._getOptions(),
        };
    }
    componentDidUpdate(props) {
        const options = this._getOptions(props);
        if (!_.isEqual(options, this.state.options))
            this.setState({ options });
    }
    render() {
        return (react_1.default.createElement(ui_core_1.ThemedSelect, { name: `filter-${this.props.column.key}`, options: this.state.options, placeholder: this.props.placeholder || this._placeholder, onChange: this._handleChange, escapeClearsValue: true, isMulti: this.props.multiSelection !== undefined ? this.props.multiSelection : false, isClearable: true, value: this.state.filters }));
    }
}
exports.AutoCompleteFilter = AutoCompleteFilter;
//# sourceMappingURL=AutoCompleteFilter.js.map