"use strict";
/*---------------------------------------------------------------------------------------------
* Copyright (c) Bentley Systems, Incorporated. All rights reserved.
* See LICENSE.md in the project root for license terms and full copyright notice.
*--------------------------------------------------------------------------------------------*/
/** @packageDocumentation
 * @module Table
 */
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ColumnDragLayer = void 0;
const classnames_1 = __importDefault(require("classnames"));
const React = __importStar(require("react"));
/**
 * React component used to portray a column being dragged during Table column reordering.
 * @public
 * @deprecated
 */
class ColumnDragLayer extends React.Component {
    constructor(props) {
        super(props);
    }
    render() {
        if (this.props.args === undefined)
            return null;
        const args = this.props.args;
        const spos = args.sourceClientOffset || { x: -1000, y: -1000 };
        const ispos = args.initialSourceClientOffset || { x: -1000, y: -1000 };
        const data = args.dataObject || /* istanbul ignore next */ {};
        const column = data.column || {};
        const width = column.width || {};
        const x = spos.x + (column && column.left);
        const y = ispos.y;
        const translate = `translate(${x}px, ${y}px)`;
        const dragLayerStyle = Object.assign({ transform: translate, WebkitTransform: translate, width }, this.props.style);
        return (React.createElement("div", { className: classnames_1.default("components-column-drag-layer", this.props.className), style: dragLayerStyle }, column.name));
    }
}
exports.ColumnDragLayer = ColumnDragLayer;
//# sourceMappingURL=ColumnDragLayer.js.map