/** @packageDocumentation
 * @module Table
 */
import ReactDataGrid = require("react-data-grid");
import { DistinctValueCollection, FilterableColumn, FilterableTable } from "../columnfiltering/ColumnFiltering";
import { FilterableColumnBase } from "../columnfiltering/FilterableColumnBase";
import { ColumnDescription, TableDataProvider } from "../TableDataProvider";
/** ReactDataGrid.Column with additional properties
 * @public
 */
export interface ReactDataGridColumn extends ReactDataGrid.Column<any> {
    /** Indicates whether the display value for the cell is treated as an icon spec. */
    icon?: boolean;
    filterableColumn?: FilterableColumn;
}
/** Table Column used by the [[Table]] component
 *  @internal
 */
export declare class TableColumn extends FilterableColumnBase {
    readonly reactDataGridColumn: ReactDataGridColumn;
    constructor(filterableTable: FilterableTable, columnDescription: ColumnDescription, reactDataGridColumn: ReactDataGridColumn);
    get key(): string;
    dataProvider?: TableDataProvider;
    distinctValueCollection?: DistinctValueCollection;
    /** Gets the distinct values for a column.
     * @return The distinct values.
     */
    getDistinctValues(maximumValueCount?: number): Promise<DistinctValueCollection>;
}
//# sourceMappingURL=TableColumn.d.ts.map