"use strict";
/*---------------------------------------------------------------------------------------------
* Copyright (c) Bentley Systems, Incorporated. All rights reserved.
* See LICENSE.md in the project root for license terms and full copyright notice.
*--------------------------------------------------------------------------------------------*/
/** @packageDocumentation
 * @module Table
 */
Object.defineProperty(exports, "__esModule", { value: true });
exports.TableColumn = void 0;
const ColumnFiltering_1 = require("../columnfiltering/ColumnFiltering");
const FilterableColumnBase_1 = require("../columnfiltering/FilterableColumnBase");
/** Table Column used by the [[Table]] component
 *  @internal
 */
class TableColumn extends FilterableColumnBase_1.FilterableColumnBase {
    constructor(filterableTable, columnDescription, reactDataGridColumn) {
        super(filterableTable, columnDescription);
        this.reactDataGridColumn = reactDataGridColumn;
    }
    get key() { return this.filterMemberKey; }
    /** Gets the distinct values for a column.
     * @return The distinct values.
     */
    async getDistinctValues(maximumValueCount) {
        if (this.dataProvider && this.dataProvider.getDistinctValues)
            return this.dataProvider.getDistinctValues(this.key, maximumValueCount);
        return new ColumnFiltering_1.DistinctValueCollection();
    }
}
exports.TableColumn = TableColumn;
//# sourceMappingURL=TableColumn.js.map