/** @packageDocumentation
 * @module Table
 */
import "./DragDropRow.scss";
import * as React from "react";
import { BreadcrumbDetailsDragDropType } from "../../breadcrumb/breadcrumbdetails/hoc/withDragDrop";
import { DragSourceProps, DropTargetProps } from "../../dragdrop/DragDropDef";
import { TableDropTargetProps } from "./withDragDrop";
/** @internal */
export interface DragDropRowProps<DragDropObject = any> {
    dragProps: DragSourceProps<DragDropObject>;
    dropProps: TableDropTargetProps<DragDropObject>;
}
interface RowWrapperProps extends React.AllHTMLAttributes<HTMLDivElement> {
    isDragging?: boolean;
    isOver?: boolean;
    canDrag?: boolean;
    canDrop?: boolean;
    canDropOn?: boolean;
    onRender?: () => void;
}
declare enum HoverMode {
    Above = 0,
    On = 1,
    Below = 2
}
/** @internal */
interface RowWrapperState {
    hoverMode: HoverMode;
}
/** @internal */
export declare class DragDropRowWrapper extends React.Component<RowWrapperProps, RowWrapperState> {
    private _root;
    readonly state: RowWrapperState;
    render(): React.ReactElement<any>;
    componentDidMount(): void;
    componentDidUpdate(): void;
    private _handleDragOver;
}
/** @internal */
export declare function DragDropRow<DragDropObject extends BreadcrumbDetailsDragDropType>(): {
    new (props: Readonly<any>): {
        createDragProps(index?: number | undefined): {};
        createDropProps(index?: number | undefined): DropTargetProps<DragDropObject>;
        render(): React.ReactElement<any>;
        context: any;
        setState<K extends never>(state: {} | ((prevState: Readonly<{}>, props: Readonly<any>) => {} | Pick<{}, K> | null) | Pick<{}, K> | null, callback?: (() => void) | undefined): void;
        forceUpdate(callback?: (() => void) | undefined): void;
        readonly props: Readonly<any> & Readonly<{
            children?: React.ReactNode;
        }>;
        state: Readonly<{}>;
        refs: {
            [key: string]: React.ReactInstance;
        };
        componentDidMount?(): void;
        shouldComponentUpdate?(nextProps: Readonly<any>, nextState: Readonly<{}>, nextContext: any): boolean;
        componentWillUnmount?(): void;
        componentDidCatch?(error: Error, errorInfo: React.ErrorInfo): void;
        getSnapshotBeforeUpdate?(prevProps: Readonly<any>, prevState: Readonly<{}>): any;
        componentDidUpdate?(prevProps: Readonly<any>, prevState: Readonly<{}>, snapshot?: any): void;
        componentWillMount?(): void;
        UNSAFE_componentWillMount?(): void;
        componentWillReceiveProps?(nextProps: Readonly<any>, nextContext: any): void;
        UNSAFE_componentWillReceiveProps?(nextProps: Readonly<any>, nextContext: any): void;
        componentWillUpdate?(nextProps: Readonly<any>, nextState: Readonly<{}>, nextContext: any): void;
        UNSAFE_componentWillUpdate?(nextProps: Readonly<any>, nextState: Readonly<{}>, nextContext: any): void;
    };
    new (props: any, context?: any): {
        createDragProps(index?: number | undefined): {};
        createDropProps(index?: number | undefined): DropTargetProps<DragDropObject>;
        render(): React.ReactElement<any>;
        context: any;
        setState<K extends never>(state: {} | ((prevState: Readonly<{}>, props: Readonly<any>) => {} | Pick<{}, K> | null) | Pick<{}, K> | null, callback?: (() => void) | undefined): void;
        forceUpdate(callback?: (() => void) | undefined): void;
        readonly props: Readonly<any> & Readonly<{
            children?: React.ReactNode;
        }>;
        state: Readonly<{}>;
        refs: {
            [key: string]: React.ReactInstance;
        };
        componentDidMount?(): void;
        shouldComponentUpdate?(nextProps: Readonly<any>, nextState: Readonly<{}>, nextContext: any): boolean;
        componentWillUnmount?(): void;
        componentDidCatch?(error: Error, errorInfo: React.ErrorInfo): void;
        getSnapshotBeforeUpdate?(prevProps: Readonly<any>, prevState: Readonly<{}>): any;
        componentDidUpdate?(prevProps: Readonly<any>, prevState: Readonly<{}>, snapshot?: any): void;
        componentWillMount?(): void;
        UNSAFE_componentWillMount?(): void;
        componentWillReceiveProps?(nextProps: Readonly<any>, nextContext: any): void;
        UNSAFE_componentWillReceiveProps?(nextProps: Readonly<any>, nextContext: any): void;
        componentWillUpdate?(nextProps: Readonly<any>, nextState: Readonly<{}>, nextContext: any): void;
        UNSAFE_componentWillUpdate?(nextProps: Readonly<any>, nextState: Readonly<{}>, nextContext: any): void;
    };
    contextType?: React.Context<any> | undefined;
};
export {};
//# sourceMappingURL=DragDropRow.d.ts.map