/** @packageDocumentation
 * @module Table
 */
import * as React from "react";
import { DragSourceProps, DropTargetProps } from "../../dragdrop/DragDropDef";
import { TableProps } from "../component/Table";
import { RowItem, TableDataProvider } from "../TableDataProvider";
/** Properties for the Table's DropTarget.
 * @beta
 * @deprecated
 */
export interface TableDropTargetProps<DragDropObject = any> extends DropTargetProps<DragDropObject> {
    /** Used for table components that allow dropping on top of node(as opposed to above or below). */
    canDropOn?: boolean;
}
/**
 * Type for DragDrop drag item
 * @beta
 * @deprecated
 */
export declare type TableDragDropType = {} | RowItem | TableDataProvider;
/**
 * Props that are injected to the HOC component.
 * @beta
 * @deprecated
 */
export interface TableDragDropProps<DragDropObject = any> {
    dragProps?: DragSourceProps<DragDropObject>;
    dropProps?: TableDropTargetProps<DragDropObject>;
}
/**
 * A HOC component that adds drag and drop functionality to the supplied table component.
 * @beta
 * @deprecated
 */
export declare function withTableDragDrop<P extends TableProps, DragDropObject extends TableDragDropType>(TableComponent: React.ComponentType<P>): React.ComponentType<P & TableDragDropProps<DragDropObject>>;
//# sourceMappingURL=withDragDrop.d.ts.map