/** @packageDocumentation
 * @module Timeline
 */
import { ScreenViewport } from "@bentley/imodeljs-frontend";
import { PlaybackSettings, TimelineDataProvider } from "./interfaces";
/** Base Timeline Data Provider
 * @alpha
 */
export declare class BaseTimelineDataProvider implements TimelineDataProvider {
    readonly id = "TestTimelineDataProvider";
    start: Date | undefined;
    end: Date | undefined;
    viewId: string;
    supportsTimelineAnimation: boolean;
    animationFraction: number;
    protected _viewport: ScreenViewport | undefined;
    constructor(viewport?: ScreenViewport);
    protected _settings: PlaybackSettings;
    loadTimelineData(): Promise<boolean>;
    /** Called to get the initial scrubber location */
    get initialDuration(): number;
    /** Called to get playback duration  */
    get duration(): number;
    set viewport(viewport: ScreenViewport | undefined);
    get viewport(): ScreenViewport | undefined;
    get loop(): boolean;
    getSettings(): PlaybackSettings;
    updateSettings(settings: PlaybackSettings): void;
    onPlaybackSettingChanged: (_settings: PlaybackSettings) => void;
    onAnimationFractionChanged: (_animationFraction: number) => void;
}
//# sourceMappingURL=BaseTimelineDataProvider.d.ts.map