import "./ContextMenu.scss";
import * as React from "react";
import { RelativePosition } from "@bentley/ui-abstract";
import { CommonProps } from "@bentley/ui-core";
/** Properties for [[ContextMenuItem]] component
 * @internal
 * @deprecated
 */
export interface MenuItem {
    /** Name of the context menu item */
    name?: string;
    /** Optional icon */
    icon?: string;
    /** Disabled */
    disabled?: boolean;
    /** Checked or not */
    checked?: boolean;
    /** Separator */
    isSeparator?: boolean;
    /** Called when the item is clicked */
    onClick?: () => void;
}
/**
 * A context menu item.
 * @internal
 * @deprecated
 */
export declare class ContextMenuItem extends React.Component<MenuItem> {
    private _onClick;
    render(): JSX.Element;
}
/** Properties for [[ContextMenu]] component
 * @internal
 * @deprecated
 */
export interface ContextMenuProps extends CommonProps {
    /** Show or hide the context menu */
    isOpened: boolean;
    /** Position the context menu relative to the parent */
    position: RelativePosition;
    /** List of context menu items */
    items?: MenuItem[];
    /** Called when the mouse is clicked outside the context menu */
    onClickOutside?: () => void;
    /** parent element */
    parent: HTMLElement | null;
}
/** Context menu for timeline component
 * @internal
 * @deprecated
 */
export declare class ContextMenu extends React.Component<ContextMenuProps> {
    render(): JSX.Element;
}
//# sourceMappingURL=ContextMenu.d.ts.map