"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ContextMenu = exports.ContextMenuItem = void 0;
/*---------------------------------------------------------------------------------------------
* Copyright (c) Bentley Systems, Incorporated. All rights reserved.
* See LICENSE.md in the project root for license terms and full copyright notice.
*--------------------------------------------------------------------------------------------*/
require("./ContextMenu.scss");
const classnames_1 = __importDefault(require("classnames"));
const React = __importStar(require("react"));
const ui_core_1 = require("@bentley/ui-core");
/* istanbul ignore next */
/**
 * A context menu item.
 * @internal
 * @deprecated
 */
class ContextMenuItem extends React.Component {
    constructor() {
        super(...arguments);
        this._onClick = (event) => {
            event.stopPropagation();
            // istanbul ignore else
            if (!this.props.disabled && !this.props.isSeparator && this.props.onClick) {
                this.props.onClick();
            }
        };
    }
    // istanbul ignore next - WIP
    render() {
        const menuClassName = classnames_1.default("contextmenu-item-wip", this.props.disabled && "disabled", this.props.checked && "checked");
        return (React.createElement(React.Fragment, null,
            this.props.isSeparator && React.createElement("div", { className: "separator", role: "separator" }),
            !this.props.isSeparator &&
                // eslint-disable-next-line jsx-a11y/click-events-have-key-events
                React.createElement("li", { className: menuClassName, onClick: this._onClick, role: "menuitem" },
                    this.props.checked && React.createElement("span", { className: "icon icon-checkmark" }),
                    (this.props.icon && !this.props.checked) && React.createElement("span", { className: classnames_1.default("user-icon icon", this.props.icon) }),
                    React.createElement("span", null, this.props.name))));
    }
}
exports.ContextMenuItem = ContextMenuItem;
/* istanbul ignore next */
/** Context menu for timeline component
 * @internal
 * @deprecated
 */
class ContextMenu extends React.Component {
    // istanbul ignore next - WIP
    render() {
        const { items, parent, position, isOpened, onClickOutside } = this.props;
        return (React.createElement(ui_core_1.Popup, { isOpen: isOpened, target: parent, position: position, onClose: onClickOutside },
            React.createElement("div", { "data-testid": "timeline-contextmenu-div", className: "contextmenu-wip" },
                React.createElement("ul", null,
                    items && items.map((item, index) => (React.createElement(ContextMenuItem, { key: index, name: item.name, icon: item.icon, disabled: item.disabled, onClick: item.onClick, isSeparator: item.isSeparator }))),
                    this.props.children))));
    }
}
exports.ContextMenu = ContextMenu;
//# sourceMappingURL=ContextMenu.js.map