"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.InlineEdit = void 0;
/*---------------------------------------------------------------------------------------------
* Copyright (c) Bentley Systems, Incorporated. All rights reserved.
* See LICENSE.md in the project root for license terms and full copyright notice.
*--------------------------------------------------------------------------------------------*/
require("./InlineEdit.scss");
const classnames_1 = __importDefault(require("classnames"));
const React = __importStar(require("react"));
const ui_abstract_1 = require("@bentley/ui-abstract");
/** Duration Inline Editor
 * @internal
 */
class InlineEdit extends React.Component {
    constructor(props) {
        super(props);
        this._inputRef = React.createRef();
        // istanbul ignore next
        this._onBlur = (event) => {
            this._sendChange(event.target.value);
        };
        this._onFocus = (event) => {
            event.target.select();
        };
        this._onKeyDown = (event) => {
            switch (event.key) {
                case ui_abstract_1.SpecialKey.Escape:
                    this.setState((prevState) => ({ value: prevState.originalValue }), () => this._inputRef.current.select());
                    break;
                case ui_abstract_1.SpecialKey.Enter:
                    this._sendChange(this.state.value);
                    break;
            }
        };
        this._onChange = (event) => {
            this.setState({ value: event.target.value });
        };
        this.state = { value: this.props.defaultValue, originalValue: this.props.defaultValue };
    }
    /** @internal */
    componentDidUpdate(prevProps, _prevState) {
        if (prevProps.defaultValue !== this.props.defaultValue) {
            this.setState((_, props) => {
                return { value: props.defaultValue, originalValue: props.defaultValue };
            });
        }
    }
    _sendChange(value) {
        // istanbul ignore else
        if (this.props.onChange)
            this.props.onChange(value);
    }
    render() {
        return (React.createElement("input", { "data-testid": "timeline-duration-edit-input", className: classnames_1.default("inline-edit-input", this.props.className), ref: this._inputRef, type: "text", value: this.state.value, onFocus: this._onFocus, onBlur: this._onBlur, onKeyDown: this._onKeyDown, onChange: this._onChange }));
    }
}
exports.InlineEdit = InlineEdit;
//# sourceMappingURL=InlineEdit.js.map