import "./PlayerButton.scss";
import * as React from "react";
import { CommonProps } from "@bentley/ui-core";
/** Player button used by buttons on timeline control
 * @internal
 */
export declare class PlayerButton extends React.PureComponent<any> {
    private _onClick;
    render(): JSX.Element;
}
/** Properties for Play/Pause button used on timeline control
 * @internal
 */
export interface PlayerButtonProps extends CommonProps {
    isPlaying: boolean;
    onPlay?: () => void;
    onPause?: () => void;
    tooltip?: string;
}
interface PlayButtonState {
    isPlaying: boolean;
}
/** Play/Pause button used on timeline control
 * @internal
 */
export declare class PlayButton extends React.Component<PlayerButtonProps, PlayButtonState> {
    constructor(props: PlayerButtonProps, context?: any);
    /** @internal */
    componentDidUpdate(): void;
    private _onClick;
    render(): JSX.Element;
}
export {};
//# sourceMappingURL=PlayerButton.d.ts.map