"use strict";
/*---------------------------------------------------------------------------------------------
* Copyright (c) Bentley Systems, Incorporated. All rights reserved.
* See LICENSE.md in the project root for license terms and full copyright notice.
*--------------------------------------------------------------------------------------------*/
/** @packageDocumentation
 * @module Timeline
 */
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.SpeedTimeline = void 0;
require("./SpeedTimeline.scss");
const classnames_1 = __importDefault(require("classnames"));
const React = __importStar(require("react"));
const react_compound_slider_1 = require("react-compound-slider");
function Handle(props) {
    const { domain: [min, max], handle: { id, value, percent }, getHandleProps, } = props;
    return React.createElement("div", Object.assign({ className: "scrubberHandle", role: "slider", "aria-valuemin": min, "aria-valuemax": max, "aria-valuenow": value, style: { left: `${percent}%` } }, getHandleProps(id)));
}
function Rails(props) {
    const { getRailProps } = props;
    return (React.createElement(React.Fragment, null,
        React.createElement("div", Object.assign({ className: "railOuter" }, getRailProps())),
        React.createElement("div", { className: "railInner" })));
}
/** Speed Timeline used in Solar Timeline component
 * @internal
 */
// eslint-disable-next-line @typescript-eslint/naming-convention
function SpeedTimeline(props) {
    // istanbul ignore next - WIP
    const onChange = (values) => {
        const value = values[0];
        if (props.onChange && (value >= 1 && value <= 6))
            props.onChange(value);
    };
    const domain = [1, 6];
    return (React.createElement("div", { className: classnames_1.default("speed-timeline", props.className) },
        React.createElement(react_compound_slider_1.Slider, { mode: 1, step: 1, domain: domain, onChange: onChange, onUpdate: onChange, values: [props.speed] },
            React.createElement(react_compound_slider_1.Rail, null, ({ getRailProps }) => React.createElement(Rails, { getRailProps: getRailProps })),
            React.createElement(react_compound_slider_1.Handles, null, ({ handles, getHandleProps }) => (React.createElement("div", { className: "slider-handles" }, handles.map((handle) => (React.createElement(Handle, { key: handle.id, handle: handle, domain: domain, getHandleProps: getHandleProps })))))))));
}
exports.SpeedTimeline = SpeedTimeline;
//# sourceMappingURL=SpeedTimeline.js.map