"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Timeline = void 0;
/*---------------------------------------------------------------------------------------------
* Copyright (c) Bentley Systems, Incorporated. All rights reserved.
* See LICENSE.md in the project root for license terms and full copyright notice.
*--------------------------------------------------------------------------------------------*/
require("./Timeline.scss");
const classnames_1 = __importDefault(require("classnames"));
const React = __importStar(require("react"));
const react_compound_slider_1 = require("react-compound-slider");
// istanbul ignore next
const formatDate = (value) => {
    let date = new Date();
    if (value)
        date = new Date(value);
    return date.toLocaleDateString();
};
/** @internal
 * @deprecated
 */
// istanbul ignore next
// eslint-disable-next-line deprecation/deprecation
function Needle({ startDate, endDate, selectedDate }) {
    const percent = (selectedDate.getTime() - startDate.getTime()) / (endDate.getTime() - startDate.getTime()) * 100;
    return (React.createElement("div", { className: "needle", style: { left: `${percent}%` } }));
}
/** @internal
 * @deprecated
 */
// istanbul ignore next
// eslint-disable-next-line deprecation/deprecation
class TooltipRail extends React.Component {
    // eslint-disable-next-line deprecation/deprecation
    constructor(props) {
        super(props);
        // istanbul ignore next - WIP
        this._onMouseEnter = () => {
            document.addEventListener("mousemove", this._onMouseMove);
        };
        // istanbul ignore next - WIP
        this._onMouseLeave = () => {
            this.setState({ value: null, percent: null });
            document.removeEventListener("mousemove", this._onMouseMove);
        };
        // istanbul ignore next - WIP
        this._onMouseMove = (e) => {
            const { activeHandleID, getEventData } = this.props;
            if (activeHandleID) {
                this.setState({ value: null, percent: null });
            }
            else {
                this.setState(getEventData(e));
            }
        };
        this.state = { value: null, percent: null };
    }
    render() {
        const { value, percent } = this.state;
        const { activeHandleID, getRailProps } = this.props;
        // istanbul ignore next - WIP
        return (React.createElement(React.Fragment, null,
            !activeHandleID && value ? (React.createElement("div", { className: "tooltip-rail", style: { left: `${percent}%` } },
                React.createElement("div", { className: "tooltip" },
                    React.createElement("span", { className: "tooltip-text" }, formatDate(value))))) : null,
            React.createElement("div", Object.assign({ className: "rail" }, getRailProps({
                onMouseEnter: this._onMouseEnter,
                onMouseLeave: this._onMouseLeave,
            }))),
            React.createElement("div", { className: "rail-center" })));
    }
}
TooltipRail.defaultProps = {
    disabled: false,
};
/** @internal
 * @deprecated
 */
// istanbul ignore next
// eslint-disable-next-line deprecation/deprecation
class Handle extends React.Component {
    // eslint-disable-next-line deprecation/deprecation
    constructor(props) {
        super(props);
        // istanbul ignore next - WIP
        this._onMouseEnter = () => {
            this.setState({ mouseOver: true });
        };
        // istanbul ignore next - WIP
        this._onMouseLeave = () => {
            this.setState({ mouseOver: false });
        };
        this.state = { mouseOver: false };
    }
    // istanbul ignore next - WIP
    render() {
        const { domain: [min, max], handle: { id, value, percent }, isActive, disabled, getHandleProps, milestone, } = this.props;
        const { mouseOver } = this.state;
        return (React.createElement(React.Fragment, null,
            (mouseOver || isActive) && !disabled ? (React.createElement("div", { className: "tooltip-rail", style: { left: `${percent}%` } },
                React.createElement("div", { className: "tooltip" },
                    React.createElement("span", { className: "tooltip-text" }, formatDate(value))))) : null,
            React.createElement("div", Object.assign({ role: "slider", "aria-valuemin": min, "aria-valuemax": max, "aria-valuenow": value, className: "handle", style: { left: `${percent}%` } }, getHandleProps(id, {
                onMouseEnter: this._onMouseEnter,
                onMouseLeave: this._onMouseLeave,
            })),
                React.createElement("span", null, milestone.label))));
    }
}
Handle.defaultProps = {
    disabled: false,
};
// istanbul ignore next
// eslint-disable-next-line deprecation/deprecation
function Tick({ tick, count, index }) {
    if (index === 0) {
        return (React.createElement("span", { className: "tick-label start" }, "Start"));
    }
    else if (index === (count - 1)) {
        return (React.createElement("span", { className: "tick-label end" }, "End"));
    }
    else {
        return (React.createElement(React.Fragment, null,
            React.createElement("div", { className: "tick-line", style: { left: `${tick.percent}%` } }),
            React.createElement("span", { className: "tick-label tick", style: { left: `${tick.percent}%` } },
                index,
                "yr")));
    }
}
/** Component used to show milestone timeline in timeline player control
 * @internal
 * @deprecated
 */
// istanbul ignore next
// eslint-disable-next-line deprecation/deprecation
class Timeline extends React.Component {
    // eslint-disable-next-line deprecation/deprecation
    constructor(props) {
        super(props);
        this._milestones = () => {
            const { milestones } = this.props;
            const handles = [];
            // istanbul ignore else
            if (milestones) {
                // eslint-disable-next-line deprecation/deprecation
                milestones.forEach((milestone) => handles.push(milestone.date.getTime()));
            }
            return handles;
        };
        // istanbul ignore else
        if (props.endDate && props.startDate) {
            const quarter = (props.endDate.getTime() - props.startDate.getTime()) / 4;
            // compute the ticks
            const ticks = [];
            ticks.push(props.startDate.getTime());
            // for (let i = this.props.startDate.getTime(); i <= (this.props.endDate.getTime()); i += oneDay) {
            for (let i = 1; i < 4; i++) {
                const newDate = props.startDate.getTime() + (quarter * i);
                ticks.push(newDate);
            }
            ticks.push(props.endDate.getTime());
            this.state = { ticks };
        }
    }
    render() {
        const { startDate, endDate, selectedDate, milestones, onChange, onUpdate } = this.props;
        const domain = [startDate.getTime(), endDate.getTime()];
        return (React.createElement("div", { className: classnames_1.default("timeline", this.props.className) },
            React.createElement(react_compound_slider_1.Slider, { mode: 1, step: 1, domain: domain, rootStyle: { position: "relative", height: "100%", margin: "0 60px" }, onUpdate: onUpdate, onChange: onChange, values: this._milestones() },
                React.createElement(react_compound_slider_1.Rail, null, (railProps) => React.createElement(TooltipRail, Object.assign({}, railProps))),
                React.createElement(react_compound_slider_1.Handles, null, ({ handles, activeHandleID, getHandleProps }) => (React.createElement("div", { className: "slider-handles" }, handles.map((handle, index) => (
                // eslint-disable-next-line deprecation/deprecation
                React.createElement(Handle, { key: handle.id, handle: handle, domain: domain, isActive: handle.id === activeHandleID, milestone: milestones[index], getHandleProps: getHandleProps })))))),
                React.createElement(react_compound_slider_1.Ticks, { values: this.state.ticks }, ({ ticks }) => (React.createElement("div", { className: "slider-ticks" }, ticks.map((tick, index) => (React.createElement(Tick, { key: tick.id, tick: tick, count: ticks.length, index: index })))))),
                React.createElement(Needle, { startDate: startDate, endDate: endDate, selectedDate: selectedDate }))));
    }
}
exports.Timeline = Timeline;
//# sourceMappingURL=Timeline.js.map