"use strict";
/*---------------------------------------------------------------------------------------------
* Copyright (c) Bentley Systems, Incorporated. All rights reserved.
* See LICENSE.md in the project root for license terms and full copyright notice.
*--------------------------------------------------------------------------------------------*/
/** @packageDocumentation
 * @module Timeline
 */
Object.defineProperty(exports, "__esModule", { value: true });
exports.TimelinePausePlayAction = exports.TimelineDateDisplay = exports.TimelineScale = void 0;
/** The timeline scale.
 * @public
 */
var TimelineScale;
(function (TimelineScale) {
    /** Show years */
    TimelineScale[TimelineScale["Years"] = 0] = "Years";
    /** Show quarters */
    TimelineScale[TimelineScale["Quarters"] = 1] = "Quarters";
    /** Show months */
    TimelineScale[TimelineScale["Months"] = 2] = "Months";
    /** Show days */
    TimelineScale[TimelineScale["Days"] = 3] = "Days";
    /** Show hours */
    TimelineScale[TimelineScale["Hours"] = 4] = "Hours";
})(TimelineScale = exports.TimelineScale || (exports.TimelineScale = {}));
/** Determines if data displayed to use is the actual date or the amount of time elapsed since project start.
 * @public
 */
var TimelineDateDisplay;
(function (TimelineDateDisplay) {
    /** Display time axis using actual start/end dates */
    TimelineDateDisplay[TimelineDateDisplay["ActualTime"] = 0] = "ActualTime";
    /** Display time axis using time relative to actual start/end dates */
    TimelineDateDisplay[TimelineDateDisplay["ProjectTime"] = 1] = "ProjectTime";
})(TimelineDateDisplay = exports.TimelineDateDisplay || (exports.TimelineDateDisplay = {}));
/** Actions for Pause/Play event
 * @public
 */
var TimelinePausePlayAction;
(function (TimelinePausePlayAction) {
    TimelinePausePlayAction[TimelinePausePlayAction["Toggle"] = 0] = "Toggle";
    TimelinePausePlayAction[TimelinePausePlayAction["Pause"] = 1] = "Pause";
    TimelinePausePlayAction[TimelinePausePlayAction["Play"] = 2] = "Play";
})(TimelinePausePlayAction = exports.TimelinePausePlayAction || (exports.TimelinePausePlayAction = {}));
//# sourceMappingURL=interfaces.js.map