/** @packageDocumentation
 * @module Toolbar
 */
import "./Item.scss";
import * as React from "react";
import { CommonProps } from "@bentley/ui-core";
/** Properties of [[ToolbarButtonItem]] component.
 * @beta
 */
export interface ToolbarButtonItemProps extends CommonProps {
    /** button icon. */
    icon?: React.ReactNode;
    /** Describes if item is active. */
    isActive?: boolean;
    /** Describes if the item is disabled. */
    isDisabled?: boolean;
    /** Function called when the item is clicked. */
    onClick?: () => void;
    /** Function called when a key is pressed. */
    onKeyDown?: (e: React.KeyboardEvent) => void;
    /** Title for the item. */
    title: string;
    /** A badge to draw. */
    badge?: React.ReactNode;
    /** If true add a gap before button. Default to false. */
    addGroupSeparator?: boolean;
}
/** Toolbar item component. Used in [[Toolbar]] component.
 * @beta
 */
export declare const ToolbarButtonItem: React.MemoExoticComponent<React.FC<ToolbarButtonItemProps>>;
//# sourceMappingURL=Item.d.ts.map