/** @packageDocumentation
 * @module ToolSettings
 */
import "./ItemWrapper.scss";
import * as React from "react";
import { CommonProps } from "@bentley/ui-core";
/** Properties of [[ItemWrapper]] component.
 * @internal future
 */
export interface ItemWrapperProps extends CommonProps {
    /** Tool setting content. */
    children?: React.ReactNode;
}
/** Used in a [[ItemWrapper]] component to display a setting.
 * @internal future
 */
export declare function ItemWrapper(props: ItemWrapperProps): JSX.Element;
/** @internal */
export declare function useResizeObserverSingleDimension<T extends Element>(onResize: (size: number) => void, useHeight: boolean): (instance: Element | null) => void;
//# sourceMappingURL=ItemWrapper.d.ts.map