"use strict";
/*---------------------------------------------------------------------------------------------
* Copyright (c) Bentley Systems, Incorporated. All rights reserved.
* See LICENSE.md in the project root for license terms and full copyright notice.
*--------------------------------------------------------------------------------------------*/
/** @packageDocumentation
 * @module ToolSettings
 */
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.useResizeObserverSingleDimension = exports.ItemWrapper = void 0;
require("./ItemWrapper.scss");
const classnames_1 = __importDefault(require("classnames"));
const React = __importStar(require("react"));
const ui_core_1 = require("@bentley/ui-core");
const ToolbarWithOverflow_1 = require("./ToolbarWithOverflow");
const Direction_1 = require("./utilities/Direction");
/** Used in a [[ItemWrapper]] component to display a setting.
 * @internal future
 */
function ItemWrapper(props) {
    const { expandsTo, direction, overflowExpandsTo, overflowDirection } = ToolbarWithOverflow_1.useToolbarWithOverflowDirectionContext();
    const { hasOverflow, onResize, useHeight } = ToolbarWithOverflow_1.useToolItemEntryContext();
    const ref = useResizeObserverSingleDimension(onResize, useHeight);
    const className = classnames_1.default("components-toolbar-item-container", hasOverflow && "components-overflown", Direction_1.OrthogonalDirectionHelpers.getCssClassName(hasOverflow ? overflowDirection : direction), Direction_1.DirectionHelpers.getCssClassName(hasOverflow ? overflowExpandsTo : expandsTo), props.className);
    return (React.createElement("div", { className: className, ref: ref, style: props.style }, props.children));
}
exports.ItemWrapper = ItemWrapper;
/** @internal */
function useResizeObserverSingleDimension(onResize, useHeight) {
    const handleResize = React.useCallback((w, h) => {
        if (useHeight)
            return onResize(h);
        return onResize(w);
    }, [useHeight, onResize]);
    return ui_core_1.useResizeObserver(handleResize);
}
exports.useResizeObserverSingleDimension = useResizeObserverSingleDimension;
//# sourceMappingURL=ItemWrapper.js.map