/** @packageDocumentation
 * @module Toolbar
 */
import "./Items.scss";
import * as React from "react";
import { CommonProps } from "@bentley/ui-core";
import { OrthogonalDirection } from "./utilities/Direction";
/** Properties of [[ToolbarItems]] component.
 * @internal
 */
export interface ToolbarItemsProps extends CommonProps {
    /** Toolbar items. */
    children?: React.ReactNode;
    /** Toolbar items direction. */
    direction: OrthogonalDirection;
}
/** Toolbar items container. Used in [[ToolbarWithOverflow]] component.
 * @internal
 */
export declare function ToolbarItems(props: ToolbarItemsProps): JSX.Element;
//# sourceMappingURL=Items.d.ts.map