/** @packageDocumentation
 * @module ToolSettings
 */
import "./Overflow.scss";
import * as React from "react";
import { CommonProps, NoChildrenProps } from "@bentley/ui-core";
import { Direction } from "./utilities/Direction";
import { RelativePosition } from "@bentley/ui-abstract";
/** Properties of [[ToolbarOverflowButton]] component.
 * @internal
 */
export interface ToolbarOverflowButtonProps extends CommonProps, NoChildrenProps {
    /** Function called when button is clicked. */
    onClick?: () => void;
    /** Function called when panel is closed. */
    onClose?: () => void;
    /** Describes if the panel is open. */
    open?: boolean;
    /** Panel expand direction. */
    expandsTo: Direction;
    /** Panel element containing the overflown buttons */
    panelNode?: React.ReactNode;
    /** Title for the item. */
    title?: string;
}
/** Button to toggle display of overflown tools.
 * @internal
 */
export declare function ToolbarOverflowButton(props: ToolbarOverflowButtonProps): JSX.Element;
/** @internal */
export declare function toToolbarOverflowRelativePosition(expandsTo: Direction): RelativePosition;
//# sourceMappingURL=Overflow.d.ts.map