"use strict";
/*---------------------------------------------------------------------------------------------
* Copyright (c) Bentley Systems, Incorporated. All rights reserved.
* See LICENSE.md in the project root for license terms and full copyright notice.
*--------------------------------------------------------------------------------------------*/
/** @packageDocumentation
 * @module ToolSettings
 */
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.toToolbarOverflowRelativePosition = exports.ToolbarOverflowButton = void 0;
require("./Overflow.scss");
const classnames_1 = __importDefault(require("classnames"));
const React = __importStar(require("react"));
const ui_core_1 = require("@bentley/ui-core");
const ToolbarWithOverflow_1 = require("./ToolbarWithOverflow");
const ItemWrapper_1 = require("./ItemWrapper");
const Direction_1 = require("./utilities/Direction");
const ui_abstract_1 = require("@bentley/ui-abstract");
/** Button to toggle display of overflown tools.
 * @internal
 */
function ToolbarOverflowButton(props) {
    const { onResize, useHeight } = ToolbarWithOverflow_1.useToolItemEntryContext();
    const [targetRef, target] = ui_core_1.useRefState();
    const ref = ItemWrapper_1.useResizeObserverSingleDimension(onResize, useHeight);
    const className = classnames_1.default("components-toolbar-item-container", "components-toolbar-overflow-button", props.className);
    const buttonClassName = classnames_1.default("components-toolbar-button-item", "components-ellipsis-icon");
    return (React.createElement("div", { className: className, ref: targetRef },
        React.createElement("button", { ref: ref, onClick: props.onClick, className: buttonClassName, style: props.style, title: props.title },
            React.createElement("div", { className: "components-icon" },
                React.createElement("div", { className: "components-ellipsis" }))),
        React.createElement(ui_core_1.Popup, { className: "components-toolbar-overflow_popup", offset: 0, showShadow: false, isOpen: props.open, onClose: props.onClose, position: toToolbarOverflowRelativePosition(props.expandsTo), target: target }, props.panelNode)));
}
exports.ToolbarOverflowButton = ToolbarOverflowButton;
/** @internal */
function toToolbarOverflowRelativePosition(expandsTo) {
    switch (expandsTo) {
        case Direction_1.Direction.Bottom:
            return ui_abstract_1.RelativePosition.Bottom;
        case Direction_1.Direction.Left:
            return ui_abstract_1.RelativePosition.Left;
        case Direction_1.Direction.Right:
            return ui_abstract_1.RelativePosition.Right;
        case Direction_1.Direction.Top:
            return ui_abstract_1.RelativePosition.Top;
    }
}
exports.toToolbarOverflowRelativePosition = toToolbarOverflowRelativePosition;
//# sourceMappingURL=Overflow.js.map