/** @packageDocumentation
 * @module Toolbar
 */
import "./PopupItem.scss";
import * as React from "react";
import { ActionButton, RelativePosition } from "@bentley/ui-abstract";
import { ToolbarButtonItemProps } from "./Item";
/** @internal */
export interface ToolbarPopupContextProps {
    readonly closePanel: () => void;
    readonly setSelectedItem?: (buttonItem: ActionButton) => void;
}
/**
 * Context used by Toolbar items in popups to close the popup panel.
 * @internal
 */
export declare const ToolbarPopupContext: React.Context<ToolbarPopupContextProps>;
/** @internal */
export declare function useToolbarPopupContext(): ToolbarPopupContextProps;
/** Properties of [[PopupItem]] component.
 * @beta
 */
export interface PopupItemProps extends ToolbarButtonItemProps {
    /** Describes if expandable item triangle indicator should be hidden. */
    hideIndicator?: boolean;
    /** Panel of the toolbar. */
    panel?: React.ReactNode;
}
/** Popup toolbar item that displays a panel
 * @beta
 */
export declare function PopupItem(props: PopupItemProps): JSX.Element;
/** @internal */
interface PopupItemPopupProps {
    children?: React.ReactNode;
    isOpen?: boolean;
    onClose(): void;
    position: RelativePosition;
    target?: HTMLElement;
}
/** @internal */
export declare function PopupItemPopup(props: PopupItemPopupProps): JSX.Element;
export {};
//# sourceMappingURL=PopupItem.d.ts.map