/** @packageDocumentation
 * @module Toolbar
 */
import "./PopupItem.scss";
import { GroupButton, RelativePosition } from "@bentley/ui-abstract";
import { ToolbarButtonItemProps } from "./Item";
import { ToolbarPanelAlignment } from "./ToolbarWithOverflow";
import { Direction } from "./utilities/Direction";
/** Properties of [[PopupItem]] component.
 * @beta
 */
export interface PopupItemWithDragProps extends ToolbarButtonItemProps {
    /** Panel of the toolbar. */
    groupItem: GroupButton;
}
/** Expandable Group button Item
 * @beta
 */
export declare function PopupItemWithDrag(props: PopupItemWithDragProps): JSX.Element;
/** @internal */
export declare function toToolbarPopupRelativePosition(expandsTo: Direction, alignment: ToolbarPanelAlignment): RelativePosition;
//# sourceMappingURL=PopupItemWithDrag.d.ts.map