/** @packageDocumentation
 * @module Toolbar
 */
import "./BackArrow.scss";
import * as React from "react";
import { CommonProps, NoChildrenProps } from "@bentley/ui-core";
/** Properties of [[BackArrow]] component.
 * @internal
 */
export interface BackArrowProps extends CommonProps, NoChildrenProps {
    /** Function called when arrow is clicked. */
    onClick?: () => void;
    /** Function called when pointer up event is received. */
    onPointerUp?: () => void;
}
/** Back arrow used in [[NestedGroup]] component.
 * @internal
 */
export declare const BackArrow: React.MemoExoticComponent<React.FC<BackArrowProps>>;
//# sourceMappingURL=BackArrow.d.ts.map