/** @packageDocumentation
 * @module Toolbar
 */
import "./Panel.scss";
import * as React from "react";
import { CommonProps } from "@bentley/ui-core";
/** Properties of [[Panel]] component.
 * @internal
 */
export interface PanelProps extends CommonProps {
    /** Panel content. */
    children?: React.ReactNode;
    onKeyDown?: (e: React.KeyboardEvent) => void;
}
/** Basic panel used in Toolbar popups. Used as base in [[Group]] and [[NestedGroup]] components.
 * @internal
 */
export declare function Panel(props: PanelProps): JSX.Element;
//# sourceMappingURL=Panel.d.ts.map