/** @packageDocumentation
 * @module Toolbar
 */
import "./Tool.scss";
import * as React from "react";
import { ActionButton, GroupButton } from "@bentley/ui-abstract";
import { CommonProps } from "@bentley/ui-core";
/** Properties of [[GroupTool]] component.
 * @internal
 */
export interface GroupToolProps extends CommonProps {
    /** Additional content, besides icon and label. */
    children?: React.ReactNode;
    /** Tool icon. */
    icon?: React.ReactNode;
    /** Describes if the item is active. */
    isActive?: boolean;
    /** Describes if the item is disabled. */
    isDisabled?: boolean;
    /** Describes if the item is focused. */
    isFocused?: boolean;
    /** Tool label. */
    label?: string;
    /** Function called when the item is clicked. */
    onClick?: (item: GroupButton | ActionButton) => void;
    /** Function called when pointer up event is received. */
    onPointerUp?: (item: GroupButton | ActionButton) => void;
    /** A badge to draw. */
    badge?: React.ReactNode;
    /** GroupButton item */
    item: GroupButton | ActionButton;
    /** Optional function to call on any KeyDown events processed by toolbar */
    onKeyDown?: (e: React.KeyboardEvent) => void;
}
/** Tool entry of tool group panel. Used in [[GroupColumn]].
 * @internal
 */
export declare function GroupTool(props: GroupToolProps): JSX.Element;
//# sourceMappingURL=Tool.d.ts.map