"use strict";
/*---------------------------------------------------------------------------------------------
* Copyright (c) Bentley Systems, Incorporated. All rights reserved.
* See LICENSE.md in the project root for license terms and full copyright notice.
*--------------------------------------------------------------------------------------------*/
/** @packageDocumentation
 * @module Toolbar
 */
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.GroupTool = void 0;
require("./Tool.scss");
const classnames_1 = __importDefault(require("classnames"));
const React = __importStar(require("react"));
const ui_core_1 = require("@bentley/ui-core");
/** Tool entry of tool group panel. Used in [[GroupColumn]].
 * @internal
 */
function GroupTool(props) {
    const ref = React.useRef(null);
    const targeted = ui_core_1.useTargeted(ref);
    const itemClassName = classnames_1.default("components-toolbar-item-expandable-group-tool-item", props.isActive && "components-active", props.isFocused && "components-focused", props.isDisabled && "components-disabled", props.onPointerUp && "components-pointer-up", targeted && "components-targeted", props.className);
    const handleClick = React.useCallback(() => {
        // istanbul ignore else
        if (!props.isDisabled && props.onClick)
            props.onClick(props.item);
    }, [props]);
    const handlePointerUp = React.useCallback(() => {
        // istanbul ignore else
        if (!props.isDisabled && props.onPointerUp)
            props.onPointerUp(props.item);
    }, [props]);
    return (React.createElement("div", { className: itemClassName, onClick: handleClick, onKeyDown: props.onKeyDown, onPointerUp: handlePointerUp, ref: ref, style: props.style, role: "button", tabIndex: 0 },
        React.createElement("div", { className: "components-icon" },
            props.icon,
            props.badge &&
                React.createElement("div", { className: "components-badge" }, props.badge)),
        React.createElement("div", { className: "components-label" }, props.label),
        props.children));
}
exports.GroupTool = GroupTool;
//# sourceMappingURL=Tool.js.map