/** @packageDocumentation
 * @module Toolbar
 */
/** Available directions.
 * @beta
 */
export declare enum Direction {
    Left = 1,
    Top = 2,
    Right = 3,
    Bottom = 4
}
/** Helpers for [[Direction]].
 * @internal
 */
export declare class DirectionHelpers {
    /** Class name of [[Direction.Left]] */
    static readonly LEFT_CLASS_NAME = "components-direction-left";
    /** Class name of [[Direction.Top]] */
    static readonly TOP_CLASS_NAME = "components-direction-top";
    /** Class name of [[Direction.Right]] */
    static readonly RIGHT_CLASS_NAME = "components-direction-right";
    /** Class name of [[Direction.Bottom]] */
    static readonly BOTTOM_CLASS_NAME = "components-direction-bottom";
    /** @returns Class name of specified [[Direction]] */
    static getCssClassName(direction: Direction): string;
    /** @returns Orthogonal direction of specified [[Direction]] */
    static getOrthogonalDirection(direction: Direction): OrthogonalDirection;
}
/** Available orthogonal directions.
 * @alpha
 */
export declare enum OrthogonalDirection {
    Vertical = 0,
    Horizontal = 1
}
/** Helpers for [[OrthogonalDirection]].
 * @internal
 */
export declare class OrthogonalDirectionHelpers {
    /** Class name of [[OrthogonalDirection.Vertical]] */
    static readonly VERTICAL_CLASS_NAME = "components-vertical";
    /** Class name of [[OrthogonalDirection.Horizontal]] */
    static readonly HORIZONTAL_CLASS_NAME = "components-horizontal";
    /** @returns Class name of specified [[OrthogonalDirection]] */
    static getCssClassName(direction: OrthogonalDirection): string;
    /** @returns Opposite of specified [[OrthogonalDirection]] */
    static inverse(direction: OrthogonalDirection): OrthogonalDirection;
}
//# sourceMappingURL=Direction.d.ts.map