"use strict";
/*---------------------------------------------------------------------------------------------
* Copyright (c) Bentley Systems, Incorporated. All rights reserved.
* See LICENSE.md in the project root for license terms and full copyright notice.
*--------------------------------------------------------------------------------------------*/
/** @packageDocumentation
 * @module Tree
 */
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.HighlightingEngine = void 0;
require("./HighlightingEngine.scss");
const React = __importStar(require("react"));
const HighlightedText_1 = require("../common/HighlightedText");
/**
 * Tree highlighting engine
 * @beta
 */
class HighlightingEngine {
    constructor(props) {
        this._searchText = props.searchText;
        this._activeMatch = props.activeMatch;
    }
    isNodeActive(node) {
        return this._activeMatch && node.id === this._activeMatch.nodeId;
    }
    getActiveMatchIndex(node) {
        return this.isNodeActive(node) ? this._activeMatch.matchIndex : undefined;
    }
    createRenderProps(node) {
        return {
            searchText: this._searchText,
            activeMatchIndex: this.getActiveMatchIndex(node),
        };
    }
    static renderNodeLabel(text, props) {
        if (props.searchText)
            return (React.createElement(HighlightedText_1.HighlightedText, Object.assign({ text: text }, props)));
        return text;
    }
}
exports.HighlightingEngine = HighlightingEngine;
HighlightingEngine.ACTIVE_CLASS_NAME = "components-activehighlight";
//# sourceMappingURL=HighlightingEngine.js.map