/** @packageDocumentation
 * @module Tree
 */
import { IImageLoader, LoadedImage } from "../common/IImageLoader";
import { BeInspireTreeNodeITree } from "./deprecated/component/BeInspireTree";
import { TreeNodeItem } from "./TreeDataProvider";
/** Interface for a tree image loader
 * @public
 */
export interface ITreeImageLoader extends IImageLoader {
    load: (item: TreeNodeItem | BeInspireTreeNodeITree) => LoadedImage | undefined;
}
/** Default image loader for the tree
 * @public
 */
export declare class TreeImageLoader implements ITreeImageLoader {
    /** Loads image data from either [[TreeNodeItem]] or [[BeInspireTreeNodeITree]] */
    load(item: TreeNodeItem | BeInspireTreeNodeITree): LoadedImage | undefined;
}
//# sourceMappingURL=ImageLoader.d.ts.map