/** @packageDocumentation
 * @module Tree
 */
import { BeEvent } from "@bentley/bentleyjs-core";
import { PageOptions } from "../common/PageOptions";
import { ITreeDataProvider, TreeDataChangesListener, TreeNodeItem } from "./TreeDataProvider";
/**
 * Used by [[SimpleTreeDataProvider]].
 * key - Parent id.
 * value - Child tree node items.
 * @public
 */
export declare type SimpleTreeDataProviderHierarchy = Map<string | undefined, TreeNodeItem[]>;
/**
 * A tree data provider using [[SimpleTreeDataProviderHierarchy]].
 * @public
 */
export declare class SimpleTreeDataProvider implements ITreeDataProvider {
    private _hierarchy;
    constructor(hierarchy: SimpleTreeDataProviderHierarchy);
    onTreeNodeChanged: BeEvent<TreeDataChangesListener>;
    private getNodesByParentId;
    getNodes(parent?: TreeNodeItem, pageOptions?: PageOptions): Promise<TreeNodeItem[]>;
    getNodesCount(parent?: TreeNodeItem): Promise<number>;
}
//# sourceMappingURL=SimpleTreeDataProvider.d.ts.map