"use strict";
/*---------------------------------------------------------------------------------------------
* Copyright (c) Bentley Systems, Incorporated. All rights reserved.
* See LICENSE.md in the project root for license terms and full copyright notice.
*--------------------------------------------------------------------------------------------*/
/** @packageDocumentation
 * @module Tree
 */
Object.defineProperty(exports, "__esModule", { value: true });
exports.TreeComponentTestId = void 0;
/**
 * Different tree component IDs that are assigned to those components as `data-testid` attribute
 * to help locate them in tests.
 *
 * @internal
 */
var TreeComponentTestId;
(function (TreeComponentTestId) {
    TreeComponentTestId["Node"] = "tree-node";
    TreeComponentTestId["NodeContents"] = "tree-node-contents";
    TreeComponentTestId["NodeExpansionToggle"] = "tree-node-expansion-toggle";
    TreeComponentTestId["NodeCheckbox"] = "tree-node-checkbox";
})(TreeComponentTestId = exports.TreeComponentTestId || (exports.TreeComponentTestId = {}));
//# sourceMappingURL=TreeComponentTestId.js.map