"use strict";
/*---------------------------------------------------------------------------------------------
* Copyright (c) Bentley Systems, Incorporated. All rights reserved.
* See LICENSE.md in the project root for license terms and full copyright notice.
*--------------------------------------------------------------------------------------------*/
/** @packageDocumentation
 * @module Tree
 */
Object.defineProperty(exports, "__esModule", { value: true });
exports.toRxjsObservable = exports.from = void 0;
const from_1 = require("rxjs/internal/observable/from");
const Observable_1 = require("rxjs/internal/Observable");
/**
 * Helper method that creates an Observable from Iterable or Promise.
 * @public
 */
function from(iterable) {
    return from_1.from(iterable);
}
exports.from = from;
/** @internal */
function toRxjsObservable(observable) {
    return new Observable_1.Observable((subscriber) => { observable.subscribe(subscriber); });
}
exports.toRxjsObservable = toRxjsObservable;
//# sourceMappingURL=Observable.js.map