/** @packageDocumentation
 * @module Tree
 */
import "./NodeContent.scss";
import { CommonProps } from "@bentley/ui-core";
import { PropertyValueRendererManager } from "../../../properties/ValueRendererManager";
import { HighlightableTreeNodeProps } from "../../HighlightingEngine";
import { TreeModelNode } from "../TreeModel";
import { TreeNodeEditorRenderer } from "./TreeNodeEditor";
/** Properties for [[TreeNodeContent]] component
 * @internal
 */
export interface TreeNodeContentProps extends CommonProps {
    node: TreeModelNode;
    showDescription?: boolean;
    highlightProps?: HighlightableTreeNodeProps;
    valueRendererManager: PropertyValueRendererManager;
    onLabelRendered?: (node: TreeModelNode) => void;
    nodeEditorRenderer?: TreeNodeEditorRenderer;
}
/** React component for displaying [[TreeNode]] label
 * @internal
 */
export declare function TreeNodeContent(props: TreeNodeContentProps): JSX.Element;
//# sourceMappingURL=NodeContent.d.ts.map