/** @packageDocumentation
 * @module Tree
 */
import * as React from "react";
import { TreeModelNode } from "../TreeModel";
/** Properties for [[TreeNodeEditor]] component
 * @beta
 */
export interface TreeNodeEditorProps {
    /** Tree node which is in editing mode. */
    node: TreeModelNode;
    /** Callback that is called when changes are committed. */
    onCommit: (node: TreeModelNode, newValue: string) => void;
    /** Callback that is called when editing is canceled. */
    onCancel: () => void;
    /** Editor style. */
    style?: React.CSSProperties;
    /** @internal */
    ignoreEditorBlur?: boolean;
}
/** Type for tree node editor renderer
 * @beta
 */
export declare type TreeNodeEditorRenderer = (props: TreeNodeEditorProps) => React.ReactNode;
/** React component for displaying tree node editor
 * @beta
 */
export declare function TreeNodeEditor(props: TreeNodeEditorProps): JSX.Element;
//# sourceMappingURL=TreeNodeEditor.d.ts.map