/** @packageDocumentation
 * @module Tree
 */
import { CheckBoxState } from "@bentley/ui-core";
import { TreeNodeItem } from "../TreeDataProvider";
import { BeInspireTreeNode } from "./component/BeInspireTree";
import { NodeLoadingOrchestrator } from "./NodeLoadingOrchestrator";
interface NodeEventManagerCallbacks {
    onSelectionModified: (selectedNodes: Array<BeInspireTreeNode<TreeNodeItem>>, deselectedNodes: Array<BeInspireTreeNode<TreeNodeItem>>) => void;
    onSelectionReplaced: (selectedNodes: Array<BeInspireTreeNode<TreeNodeItem>>) => void;
    onCheckboxStateChanged: (stateChanges: Array<{
        node: BeInspireTreeNode<TreeNodeItem>;
        newState: CheckBoxState;
    }>) => void;
}
/** @internal @deprecated */
export declare class NodeEventManager {
    private _loadingOrchestrator;
    private _bulkCheckboxActionsEnabled;
    private _callbacks;
    constructor(loadingOrchestrator: NodeLoadingOrchestrator, bulkCheckboxActionsEnabled: boolean, callbacks: NodeEventManagerCallbacks);
    modifySelection(selectedNodes: Array<BeInspireTreeNode<TreeNodeItem>>, deselectedNodes: Array<BeInspireTreeNode<TreeNodeItem>>): void;
    replaceSelection(selectedNodes: Array<BeInspireTreeNode<TreeNodeItem>>): void;
    /**
     * Selects all visible nodes that are between node1 and node2. Both nodes
     * must be loaded and can be supplied in any order.
     */
    selectNodesBetween(replace: boolean, node1: BeInspireTreeNode<TreeNodeItem>, node2: BeInspireTreeNode<TreeNodeItem>): void;
    setCheckboxState(node: BeInspireTreeNode<TreeNodeItem>, state: CheckBoxState): void;
}
export {};
//# sourceMappingURL=NodeEventManager.d.ts.map