/** @packageDocumentation
 * @module Tree
 */
import "./NodeContent.scss";
import * as React from "react";
import { CommonProps } from "@bentley/ui-core";
import { PropertyValueRendererManager } from "../../../properties/ValueRendererManager";
import { HighlightableTreeNodeProps } from "../../HighlightingEngine";
import { TreeNodeItem } from "../../TreeDataProvider";
import { CellEditingEngine } from "../CellEditingEngine";
import { BeInspireTreeNode } from "./BeInspireTree";
/** Properties for [[TreeNodeContent]] component
 * @internal @deprecated
 */
export interface TreeNodeContentProps extends CommonProps {
    node: BeInspireTreeNode<TreeNodeItem>;
    showDescription?: boolean;
    highlightProps?: HighlightableTreeNodeProps;
    valueRendererManager: PropertyValueRendererManager;
    cellEditing?: CellEditingEngine;
    /**
     * Called when all of the component tasks are done.
     * There are 3 different conditions:
     * * Props and node did not update so there is no need to render.
     * * Provided label function was synchronous and the render finished.
     * * Provided label function was asynchronous and the second render finished.
     */
    onFinalRenderComplete?: (renderId: string) => void;
    /**
     * Id specified by the parent component to identify all
     * nodes rendered at one request
     */
    renderId?: string;
}
/** @internal @deprecated */
export interface TreeNodeContentState {
    label: React.ReactNode;
    renderInfo?: {
        timestamp: number;
        counter: number;
    };
}
/** React component for displaying [[TreeNode]] label
 * @internal @deprecated
 */
export declare class TreeNodeContent extends React.Component<TreeNodeContentProps, TreeNodeContentState> {
    constructor(props: TreeNodeContentProps);
    private getStyle;
    private nodeToPropertyRecord;
    private getLabel;
    private _onLabelStateChanged;
    private updateLabel;
    componentDidMount(): void;
    private static doPropsDiffer;
    private static needsLabelUpdate;
    componentDidUpdate(prevProps: TreeNodeContentProps): void;
    shouldComponentUpdate(nextProps: TreeNodeContentProps, nextState: TreeNodeContentState): boolean;
    render(): JSX.Element;
}
//# sourceMappingURL=NodeContent.d.ts.map