"use strict";
/*---------------------------------------------------------------------------------------------
* Copyright (c) Bentley Systems, Incorporated. All rights reserved.
* See LICENSE.md in the project root for license terms and full copyright notice.
*--------------------------------------------------------------------------------------------*/
/** @packageDocumentation
 * @module Tree
 */
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.DragDropTreeNode = exports.DragDropTreeNodeComponent = void 0;
require("./DragDropTreeNode.scss");
const classnames_1 = __importDefault(require("classnames"));
const React = __importStar(require("react"));
const withDragSource_1 = require("../../../dragdrop/withDragSource");
const withDropTarget_1 = require("../../../dragdrop/withDropTarget");
var HoverMode;
(function (HoverMode) {
    HoverMode[HoverMode["Above"] = 0] = "Above";
    HoverMode[HoverMode["On"] = 1] = "On";
    HoverMode[HoverMode["Below"] = 2] = "Below";
})(HoverMode || (HoverMode = {}));
// Used internally in ./Tree.tsx
/** @internal @deprecated  */
class DragDropTreeNodeComponent extends React.Component {
    constructor() {
        super(...arguments);
        this._root = null;
        this.state = {
            hoverMode: HoverMode.On,
        };
        this._handleDragOver = (event) => {
            if (this.props.isOver && this._root) {
                const rect = this._root.getBoundingClientRect();
                let relativeY = (event.clientY - rect.top) / rect.height;
                // istanbul ignore next
                if (this.props.style !== undefined &&
                    this.props.style.top !== undefined && typeof this.props.style.top === "number" &&
                    this.props.style.height !== undefined && typeof this.props.style.height === "number")
                    relativeY = (event.clientY - this.props.style.top) / this.props.style.height;
                if (relativeY < 1 / 3) {
                    if (this.state.hoverMode !== HoverMode.Above)
                        this.setState({ hoverMode: HoverMode.Above });
                }
                else if (relativeY < 2 / 3) {
                    if (this.state.hoverMode !== HoverMode.On)
                        this.setState({ hoverMode: HoverMode.On });
                }
                else {
                    if (this.state.hoverMode !== HoverMode.Below)
                        this.setState({ hoverMode: HoverMode.Below });
                }
            }
        };
    }
    render() {
        const _a = this.props, { isOver, isDragging, canDrag, canDrop } = _a, props = __rest(_a, ["isOver", "isDragging", "canDrag", "canDrop"]); // eslint-disable-line @typescript-eslint/no-unused-vars
        const mode = this.state.hoverMode;
        const classes = classnames_1.default("node-drop-target", {
            above: canDrop && isOver && mode === HoverMode.Above,
            on: canDrop && isOver && mode === HoverMode.On,
            below: canDrop && isOver && mode === HoverMode.Below,
            dragging: isDragging,
        });
        return (React.createElement("div", Object.assign({}, props, { "data-testid": "node-drop-target", className: classes, ref: (el) => { this._root = el; }, onDragOver: this._handleDragOver }), this.props.children));
    }
}
exports.DragDropTreeNodeComponent = DragDropTreeNodeComponent;
/** @internal */
function DragDropTreeNode() {
    return withDropTarget_1.withDropTarget(withDragSource_1.withDragSource(DragDropTreeNodeComponent));
}
exports.DragDropTreeNode = DragDropTreeNode;
//# sourceMappingURL=DragDropTreeNode.js.map