/** @packageDocumentation
 * @module Tree
 */
import * as React from "react";
import { DragSourceProps, DropTargetProps } from "../../../dragdrop/DragDropDef";
import { TreeDataProvider, TreeNodeItem } from "../../TreeDataProvider";
import { TreeProps } from "../component/Tree";
/**
 * Type for drag and drop,
 * @beta
 * @deprecated
 */
export declare type TreeDragDropType = {} | TreeNodeItem | TreeDataProvider;
/**
 * Props that are injected to the HOC component.
 * @beta
 * @deprecated
 */
export interface TreeDragDropProps<DragDropObject = any> {
    dragProps?: DragSourceProps<DragDropObject>;
    dropProps?: DropTargetProps<DragDropObject>;
}
/**
 * A HOC component that adds drag and drop functionality to the supplied tree component.
 * @beta
 * @deprecated
 */
export declare function DEPRECATED_withTreeDragDrop<P extends TreeProps, DragDropObject extends TreeDragDropType>(TreeComponent: React.ComponentType<P>): React.ComponentType<P & TreeDragDropProps<DragDropObject>>;
//# sourceMappingURL=withDragDrop.d.ts.map